---- $Id$
SET FOREIGN_KEY_CHECKS = 0;
USE eventlog;

DROP TABLE IF EXISTS `SB_Applications`;
CREATE TABLE `SB_Applications` (`APPL_ID` bigint(19) NOT NULL default '0', `APPL_NAME` varchar(200) NOT NULL default '', `APPL_DESC` text, PRIMARY KEY  (`APPL_ID`), UNIQUE KEY `SB_Applications_UK0` (`APPL_NAME`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `TableDetails`;
--CREATE TABLE `TableDetails` (`TABLE_ID` bigint(19) NOT NULL default '0', `APPL_ID` bigint(19) NOT NULL default '0', `TABLE_NAME` varchar(100) NOT NULL default '', `TABLE_DESC` text, `DISPLAY_NAME` varchar(100) default NULL, `SYSTEM` tinyint(1) NOT NULL default '0', `TABLE_ORDER` bigint(19) default NULL, PRIMARY KEY  (`TABLE_ID`), UNIQUE KEY `TableDetails_UK0` (`TABLE_NAME`), KEY `Appl_id_IDX` (`APPL_ID`), CONSTRAINT `Appl_id` FOREIGN KEY (`APPL_ID`) REFERENCES `SB_Applications` (`APPL_ID`) ON DELETE CASCADE) ENGINE=InnoDB;
CREATE TABLE `TableDetails` (`TABLE_ID` bigint(19) NOT NULL default '0', `APPL_ID` bigint(19) NOT NULL default '0', `TABLE_NAME` varchar(100) NOT NULL default '', `TABLE_DESC` text, `DISPLAY_NAME` varchar(100) default NULL, `SYSTEM` tinyint(1) NOT NULL default '0', `TABLE_ORDER` bigint(19) default NULL, `CREATETABLE` tinyint(1) NOT NULL default '1', PRIMARY KEY  (`TABLE_ID`), UNIQUE KEY `TableDetails_UK0` (`TABLE_NAME`), KEY `Appl_id_IDX` (`APPL_ID`), KEY `TableDetails_IDX1` (`TABLE_ORDER`), CONSTRAINT `Appl_id` FOREIGN KEY (`APPL_ID`) REFERENCES `SB_Applications` (`APPL_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `ColumnDetails`;
CREATE TABLE `ColumnDetails` (`COLUMN_ID` bigint(19) NOT NULL default '0', `TABLE_ID` bigint(19) NOT NULL default '0', `COLUMN_NAME` varchar(150) NOT NULL default '', `DATA_TYPE` varchar(10) NOT NULL default '', `ISNULLABLE` tinyint(1) NOT NULL default '0', `ISUNIQUE` tinyint(1) NOT NULL default '0', `GENERATOR_NAME` varchar(250) default NULL, `NAME_COLUMN` varchar(150) default NULL, `COLUMN_DESC` text, `DEFAULT_VALUE` varchar(255) default NULL, `MAX_SIZE` int(10) default NULL, `DISPLAY_NAME` varchar(150) default NULL, `SQL_TYPE` int, PRIMARY KEY  (`COLUMN_ID`), UNIQUE KEY `ColumnDetails_UK0` (`GENERATOR_NAME`), KEY `ColumnDetails_FK1_IDX` (`TABLE_ID`), CONSTRAINT `ColumnDetails_FK1` FOREIGN KEY (`TABLE_ID`) REFERENCES `TableDetails` (`TABLE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `RangeValues`;
CREATE TABLE `RangeValues` (`COLUMN_ID` bigint(19) NOT NULL default '0', `RANGE_FROM` varchar(50) NOT NULL default '', `RANGE_TO` varchar(50) NOT NULL default '', PRIMARY KEY  (`COLUMN_ID`), KEY `RangeValues_FK1_IDX` (`COLUMN_ID`), CONSTRAINT `RangeValues_FK1` FOREIGN KEY (`COLUMN_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `AllowedValues`;
CREATE TABLE `AllowedValues` (`COLUMN_ID` bigint(19) NOT NULL default '0', `VALUE` varchar(180) NOT NULL default '', PRIMARY KEY  (`COLUMN_ID`,`VALUE`), KEY `AllowedValues_FK1_IDX` (`COLUMN_ID`), CONSTRAINT `AllowedValues_FK1` FOREIGN KEY (`COLUMN_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `AllowedPattern`;
CREATE TABLE `AllowedPattern` (`COLUMN_ID` bigint(19) NOT NULL default '0', `PATTERN` varchar(150) NOT NULL default '', PRIMARY KEY  (`COLUMN_ID`), KEY `AllowedPattern_FK1_IDX` (`COLUMN_ID`), CONSTRAINT `AllowedPattern_FK1` FOREIGN KEY (`COLUMN_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `ConstraintDefinition`;
CREATE TABLE `ConstraintDefinition` (`CONSTRAINT_ID` bigint(19) NOT NULL default '0', `CONSTRAINT_NAME` varchar(100) NOT NULL default '', `TABLE_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`CONSTRAINT_ID`), UNIQUE KEY `ConstraintDefinition_UK0` (`CONSTRAINT_NAME`), KEY `ConstraintDefinition_FK1_IDX` (`TABLE_ID`), CONSTRAINT `ConstraintDefinition_FK1` FOREIGN KEY (`TABLE_ID`) REFERENCES `TableDetails` (`TABLE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `UniqueKeyDefinition`;
CREATE TABLE `UniqueKeyDefinition` (`UNIQUE_CONS_ID` bigint(19) NOT NULL default '0', `COLUMN_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`UNIQUE_CONS_ID`,`COLUMN_ID`), KEY `UniqueKeyDefinition_FK1_IDX` (`UNIQUE_CONS_ID`), KEY `UniqueKeyDefinition_FK2_IDX` (`COLUMN_ID`), CONSTRAINT `UniqueKeyDefinition_FK1` FOREIGN KEY (`UNIQUE_CONS_ID`) REFERENCES `ConstraintDefinition` (`CONSTRAINT_ID`) ON DELETE CASCADE, CONSTRAINT `UniqueKeyDefinition_FK2` FOREIGN KEY (`COLUMN_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `PKDefinition`;
CREATE TABLE `PKDefinition` (`PK_COLUMN_ID` bigint(19) NOT NULL default '0', `PK_ID` bigint(19) NOT NULL default '0', `POSITION` int(10) NOT NULL default '0', PRIMARY KEY  (`PK_COLUMN_ID`), KEY `PKDefinition_FK1_IDX` (`PK_ID`), KEY `PKDefinition_FK2_IDX` (`PK_COLUMN_ID`), CONSTRAINT `PKDefinition_FK1` FOREIGN KEY (`PK_ID`) REFERENCES `ConstraintDefinition` (`CONSTRAINT_ID`) ON DELETE CASCADE, CONSTRAINT `PKDefinition_FK2` FOREIGN KEY (`PK_COLUMN_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `FKDefinition`;
CREATE TABLE `FKDefinition` (`FK_CONSTRAINT_ID` bigint(19) NOT NULL default '0', `FK_REF_TABLE_ID` bigint(19) NOT NULL default '0', `FK_CONSTRAINT` varchar(25) NOT NULL default 'ON-DELETE-RESTRICT', `IS_BIDIRECTIONAL` tinyint(1) NOT NULL default '0', `FK_DESC` varchar(250) default NULL, PRIMARY KEY  (`FK_CONSTRAINT_ID`), KEY `FKDefinition_FK1_IDX` (`FK_CONSTRAINT_ID`), KEY `FKDefinition_FK2_IDX` (`FK_REF_TABLE_ID`), CONSTRAINT `FKDefinition_FK1` FOREIGN KEY (`FK_CONSTRAINT_ID`) REFERENCES `ConstraintDefinition` (`CONSTRAINT_ID`) ON DELETE CASCADE, CONSTRAINT `FKDefinition_FK2` FOREIGN KEY (`FK_REF_TABLE_ID`) REFERENCES `TableDetails` (`TABLE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `FKColumnDefinition`;
CREATE TABLE `FKColumnDefinition` (`FK_CONSTRAINT_ID` bigint(19) NOT NULL default '0', `FK_LOCAL_COL_ID` bigint(19) NOT NULL default '0', `FK_REF_COL_ID` bigint(19) NOT NULL default '0', `POSITION` int(10) NOT NULL default '0', PRIMARY KEY  (`FK_CONSTRAINT_ID`,`FK_LOCAL_COL_ID`), KEY `FKColumnDefinition_FK1_IDX` (`FK_CONSTRAINT_ID`), KEY `FKColumnDefinition_FK2_IDX` (`FK_LOCAL_COL_ID`), KEY `FKColumnDefinition_FK3_IDX` (`FK_REF_COL_ID`), CONSTRAINT `FKColumnDefinition_FK1` FOREIGN KEY (`FK_CONSTRAINT_ID`) REFERENCES `FKDefinition` (`FK_CONSTRAINT_ID`) ON DELETE CASCADE, CONSTRAINT `FKColumnDefinition_FK2` FOREIGN KEY (`FK_LOCAL_COL_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE, CONSTRAINT `FKColumnDefinition_FK3` FOREIGN KEY (`FK_REF_COL_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `IndexDefinition`;
CREATE TABLE `IndexDefinition` (`INDEX_CONS_ID` bigint(19) NOT NULL default '0', `COLUMN_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`INDEX_CONS_ID`,`COLUMN_ID`), KEY `IndexDefinition_FK1_IDX` (`INDEX_CONS_ID`), KEY `IndexDefinition_FK2_IDX` (`COLUMN_ID`), CONSTRAINT `IndexDefinition_FK1` FOREIGN KEY (`INDEX_CONS_ID`) REFERENCES `ConstraintDefinition` (`CONSTRAINT_ID`) ON DELETE CASCADE, CONSTRAINT `IndexDefinition_FK2` FOREIGN KEY (`COLUMN_ID`) REFERENCES `ColumnDetails` (`COLUMN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `JoinCriteria`;
CREATE TABLE `JoinCriteria` (`QUERYID` bigint(19) NOT NULL default '0', `CRITERIAID` bigint(19) NOT NULL default '0', `LOGICALREPRESENTATION` varchar(200) default NULL, PRIMARY KEY  (`QUERYID`,`CRITERIAID`), KEY `JoinCriteria_FK_IDX` (`QUERYID`), CONSTRAINT `JoinCriteria_FK` FOREIGN KEY (`QUERYID`) REFERENCES `SelectQuery` (`QUERYID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `JoinRelCriteria`;
CREATE TABLE `JoinRelCriteria` (`QUERYID` bigint(19) NOT NULL default '0', `CRITERIAID` bigint(19) NOT NULL default '0', `RELATIONALCRITERIAID` bigint(19) NOT NULL default '0', `TABLEALIAS` varchar(50) default NULL, `COLUMNNAME` varchar(50) default NULL, `COMPARATOR` int(10) default NULL, `VALUE` text, `CASESENSITIVE` tinyint(1) NOT NULL default '1', PRIMARY KEY  (`QUERYID`,`CRITERIAID`,`RELATIONALCRITERIAID`), KEY `JoinRelCriteria_FK_IDX` (`QUERYID`,`CRITERIAID`), KEY `JoinRelCriteria_FK2_IDX` (`QUERYID`,`TABLEALIAS`), CONSTRAINT `JoinRelCriteria_FK` FOREIGN KEY (`QUERYID`, `CRITERIAID`) REFERENCES `JoinCriteria` (`QUERYID`, `CRITERIAID`) ON DELETE CASCADE, CONSTRAINT `JoinRelCriteria_FK2` FOREIGN KEY (`QUERYID`, `TABLEALIAS`) REFERENCES `SelectTable` (`QUERYID`, `TABLEALIAS`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `DataSource`;
CREATE TABLE `DataSource` (`DSID` bigint(19) NOT NULL default '0', `DSNAME` varchar(50) NOT NULL default '', `ADAPTERCLASS` varchar(200) NOT NULL default '', `DESCRIPTION` varchar(100) default NULL, `ISACTIVE` tinyint(1) NOT NULL default '1', PRIMARY KEY  (`DSID`), UNIQUE KEY `DataSource_UK1` (`DSNAME`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `AdventNetErrorCode`;
CREATE TABLE `AdventNetErrorCode` (`ERRORID` bigint(19) NOT NULL default '0', `ERRORCODE` int(10) NOT NULL default '0', `ERRORSTRING` varchar(100) NOT NULL default '', `ERRORMESSAGE` varchar(250) default NULL, PRIMARY KEY  (`ERRORID`), UNIQUE KEY `AdventNetErrorCode_UK1` (`ERRORCODE`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `MySQLErrorCode`;
CREATE TABLE `MySQLErrorCode` (`ERRORID` bigint(19) NOT NULL default '0', `ERRORCODE` int(10) NOT NULL default '0', `ERRORMESSAGE` varchar(250) default NULL, PRIMARY KEY  (`ERRORID`,`ERRORCODE`), UNIQUE KEY `MySQLErrorCode_UK1` (`ERRORCODE`), KEY `MySQLErrorCode_FK_IDX` (`ERRORID`), CONSTRAINT `MySQLErrorCode_FK` FOREIGN KEY (`ERRORID`) REFERENCES `AdventNetErrorCode` (`ERRORID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `OracleErrorCode`;
CREATE TABLE `OracleErrorCode` (`ERRORID` bigint(19) NOT NULL default '0', `ERRORCODE` int(10) NOT NULL default '0', `ERRORMESSAGE` varchar(250) default NULL, PRIMARY KEY  (`ERRORID`,`ERRORCODE`), UNIQUE KEY `OracleErrorCode_UK1` (`ERRORCODE`), KEY `OracleErrorCode_FK_IDX` (`ERRORID`), CONSTRAINT `OracleErrorCode_FK` FOREIGN KEY (`ERRORID`) REFERENCES `AdventNetErrorCode` (`ERRORID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `MsSQLErrorCode`;
CREATE TABLE `MsSQLErrorCode` (`ERRORID` bigint(19) NOT NULL default '0', `ERRORCODE` int(10) NOT NULL default '0', `ERRORMESSAGE` varchar(250) default NULL, PRIMARY KEY  (`ERRORID`,`ERRORCODE`), UNIQUE KEY `MsSQLErrorCode_UK1` (`ERRORCODE`), KEY `MsSQLErrorCode_FK_IDX` (`ERRORID`), CONSTRAINT `MsSQLErrorCode_FK` FOREIGN KEY (`ERRORID`) REFERENCES `AdventNetErrorCode` (`ERRORID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `PgSQLErrorCode`;
CREATE TABLE `PgSQLErrorCode` (`ERRORID` bigint(19) NOT NULL default '0', `ERRORCODE` varchar(10) NOT NULL default '', `ERRORMESSAGE` varchar(250) default NULL, PRIMARY KEY  (`ERRORID`,`ERRORCODE`), UNIQUE KEY `PgSQLErrorCode_UK1` (`ERRORCODE`), KEY `PgSQLErrorCode_FK_IDX` (`ERRORID`), CONSTRAINT `PgSQLErrorCode_FK` FOREIGN KEY (`ERRORID`) REFERENCES `AdventNetErrorCode` (`ERRORID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Module`;
--CREATE TABLE `Module` (`MODULE_ID` bigint(19) NOT NULL default '0', `MODULEORDER` int(5) NOT NULL default '0', `MODULENAME` varchar(100) NOT NULL default '', `VERSION_NO` varchar(100) default NULL, PRIMARY KEY  (`MODULE_ID`), UNIQUE KEY `Module_UK0` (`MODULENAME`), UNIQUE KEY `Module_UK1` (`MODULEORDER`)) ENGINE=InnoDB;
CREATE TABLE `Module` (`MODULE_ID` bigint(19) NOT NULL default '0', `MODULEORDER` int(5) NOT NULL default '0', `MODULENAME` varchar(100) NOT NULL default '', `VERSION_NO` varchar(100) default NULL, `ISPOPULATED` tinyint(1) default NULL, PRIMARY KEY  (`MODULE_ID`), UNIQUE KEY `Module_UK0` (`MODULENAME`), UNIQUE KEY `Module_UK1` (`MODULEORDER`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Bean`;
CREATE TABLE `Bean` (`BEAN_ID` bigint(19) NOT NULL default '0', `MODULE_ID` bigint(19) NOT NULL default '0', `BEAN_NAME` varchar(100) NOT NULL default '', `CLASSNAME` varchar(250) NOT NULL default '', `TRANSACTION_TYPE` int(4) NOT NULL default '1', PRIMARY KEY  (`BEAN_ID`), UNIQUE KEY `Bean_UK0` (`BEAN_NAME`), KEY `Bean_FK_IDX` (`MODULE_ID`), CONSTRAINT `Bean_FK` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Service`;
CREATE TABLE `Service` (`SERVICE_ID` bigint(19) NOT NULL default '0', `ORDER_ID` int(5) default NULL, `MODULE_ID` bigint(19) NOT NULL default '0', `SERVICE_NAME` varchar(100) NOT NULL default '', `CLASSNAME` varchar(250) NOT NULL default '', PRIMARY KEY  (`SERVICE_ID`), UNIQUE KEY `Service_UK0` (`SERVICE_NAME`), KEY `Service_FK_IDX` (`MODULE_ID`), CONSTRAINT `Service_FK` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `BeanInterceptor`;
CREATE TABLE `BeanInterceptor` (`BEAN_INCP_ID` bigint(19) NOT NULL default '0', `ORDER_NO` int(5) NOT NULL default '0', `BEAN_ID` bigint(19) NOT NULL default '0', `INCP_NAME` varchar(100) default NULL, `CLASSNAME` varchar(250) NOT NULL default '', PRIMARY KEY  (`BEAN_INCP_ID`), UNIQUE KEY `BeanInterceptor_UK` (`ORDER_NO`,`BEAN_ID`), KEY `BeanInterceptor_FK_IDX` (`BEAN_ID`), CONSTRAINT `BeanInterceptor_FK` FOREIGN KEY (`BEAN_ID`) REFERENCES `Bean` (`BEAN_ID`) ON DELETE CASCADE) ENGINE=InnoDB; 

DROP TABLE IF EXISTS `ModuleContext`;
CREATE TABLE `ModuleContext` (`MODULE_ID` bigint(19) NOT NULL default '0', `CONTEXT` varchar(50) NOT NULL default '', PRIMARY KEY  (`MODULE_ID`,`CONTEXT`), UNIQUE KEY `ModuleContext_UK0` (`CONTEXT`), KEY `ModuleContext_FK1_IDX` (`MODULE_ID`), CONSTRAINT `ModuleContext_FK1` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE) ENGINE=InnoDB; 

ALTER TABLE `ConfFile` MODIFY `HANDLERCLASS` varchar(200) default NULL;
ALTER TABLE `UVHValues` ADD `TABLE_ID` bigint(19) default NULL;

ALTER TABLE `ConfFileToModule` ADD `MODULE_ID` bigint(19);
-- opulate SeqGenCol ConfFileToModule, MODULE_ID, MODULENAME, Module, MODULE_ID
ALTER TABLE `ConfFileToModule` MODIFY `MODULE_ID` bigint(19) NOT NULL;
ALTER TABLE `ConfFileToModule` DROP FOREIGN KEY `ConfFileToModule_FK2`;
ALTER TABLE `ConfFileToModule` DROP INDEX `ConfFileToModule_FK2_IDX`;
ALTER TABLE `ConfFileToModule` ADD KEY `ConfFileToModule_FK2_IDX` (`MODULE_ID`);
ALTER TABLE `ConfFileToModule` ADD CONSTRAINT `ConfFileToModule_FK2` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE;

--DROP TABLE IF EXISTS `ConfFileToModule`;
--CREATE TABLE `ConfFileToModule` (`FILEID` bigint(19) NOT NULL default '0', `MODULE_ID` bigint(19) default NULL, PRIMARY KEY  (`FILEID`), KEY `ConfFileToModule_FK1_IDX` (`FILEID`), KEY `ConfFileToModule_FK2_IDX` (`MODULE_ID`), CONSTRAINT `ConfFileToModule_FK1` FOREIGN KEY (`FILEID`) REFERENCES `ConfFile` (`FILEID`) ON DELETE CASCADE, CONSTRAINT `ConfFileToModule_FK2` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `BeanProperties`;
CREATE TABLE `BeanProperties` (`BEANPROP_ID` bigint(19) NOT NULL default '0', `BEAN_ID` bigint(19) NOT NULL default '0', `PROPERTY` varchar(100) NOT NULL default '', `VALUE` varchar(100) NOT NULL default '', PRIMARY KEY  (`BEANPROP_ID`), KEY `BeanProperties_FK_IDX` (`BEAN_ID`), CONSTRAINT `BeanProperties_FK` FOREIGN KEY (`BEAN_ID`) REFERENCES `Bean` (`BEAN_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `ServiceProperties`;
CREATE TABLE `ServiceProperties` (`SERVICEPROP_ID` bigint(19) NOT NULL default '0', `SERVICE_ID` bigint(19) NOT NULL default '0', `PROPERTY` varchar(100) NOT NULL default '', `VALUE` varchar(100) NOT NULL default '', PRIMARY KEY  (`SERVICEPROP_ID`), KEY `ServiceProperties_FK_IDX` (`SERVICE_ID`), CONSTRAINT `ServiceProperties_FK` FOREIGN KEY (`SERVICE_ID`) REFERENCES `Service` (`SERVICE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `ServerStatus`;
CREATE TABLE `ServerStatus` (`SERVERID` bigint(19) NOT NULL default '0', `SERVERNAME` varchar(100) NOT NULL default '', `STATUS` int(10) default NULL, PRIMARY KEY  (`SERVERID`), UNIQUE KEY `ServerStatus_UK1` (`SERVERNAME`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `DBAdapter`;
CREATE TABLE `DBAdapter` (`DSID` bigint(19) NOT NULL default '0', `SQLGENERATOR` varchar(200) NOT NULL default '', `DRIVERNAME` varchar(200) NOT NULL default '', `URL` varchar(200) NOT NULL default '', `USERNAME` varchar(30) NOT NULL default '', `PASSWORD` varchar(30) default NULL, `TRANSACTION_LEVEL` varchar(50) NOT NULL default 'TRANSACTION_READ_COMMITTED', `MIN_CONN_COUNT` int(10) NOT NULL default '1', `MAX_CONN_COUNT` int(10) NOT NULL default '5', PRIMARY KEY  (`DSID`), KEY `DBAdapter_FK1_IDX` (`DSID`), CONSTRAINT `DBAdapter_FK1` FOREIGN KEY (`DSID`) REFERENCES `DataSource` (`DSID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Tabs_Populated_ByXml`;
CREATE TABLE `Tabs_Populated_ByXml` (`TABLE_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`TABLE_ID`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `SelectSQLString`;
CREATE TABLE `SelectSQLString` (`QUERY_ID` bigint(19) NOT NULL default '0', `QUERY_KEY` varchar(100) NOT NULL default '', `SELECT_SQL` text NOT NULL, PRIMARY KEY  (`QUERY_ID`), UNIQUE KEY `SelectSQLString_UK0` (`QUERY_KEY`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `SystemTemplateHandler`;
CREATE TABLE `SystemTemplateHandler` (`HANDLER_ID` bigint(19) NOT NULL default '0', `HANDLER_NAME` varchar(100) NOT NULL default '', `CLASS_NAME` varchar(250) NOT NULL default 'NULL', PRIMARY KEY  (`HANDLER_ID`), UNIQUE KEY `SystemTemplateHandler_UK0` (`HANDLER_NAME`)) ENGINE=InnoDB;

-- Logging Changes
ALTER TABLE `Logger` DROP FOREIGN KEY `Crid_FK`;
ALTER TABLE `Logger` DROP INDEX `Crid_FK_IDX`;
ALTER TABLE `Logger` DROP `CRID`;

-- I18N Changes
--DROP TABLE IF EXISTS `ResourceBundleStack`;
--DROP TABLE IF EXISTS `ResourceBundle`;

DROP TABLE IF EXISTS `I18nLanguageCountry`;
CREATE TABLE `I18nLanguageCountry` (`LANG_ID` bigint(19) NOT NULL default '0', `LANGUAGE_NAME` varchar(127) NOT NULL default '', `COUNTRY_NAME` varchar(50) default NULL, `REGION` varchar(50) NOT NULL default '', `CODE` varchar(50) default NULL, PRIMARY KEY  (`LANG_ID`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `I18nLocale`;
CREATE TABLE `I18nLocale` (`LOCALE_ID` bigint(19) NOT NULL default '0', `LANG_ID` bigint(19) NOT NULL default '0', `PUBLISHED_ON` bigint(19) default NULL, `LAST_MODIFIED_ON` bigint(19) default NULL, `ID_NO` bigint(19) NOT NULL default '0', `NAME` varchar(255) default NULL, PRIMARY KEY  (`LOCALE_ID`), KEY `I18NLOCALE1_FK_IDX` (`LANG_ID`), CONSTRAINT `I18NLOCALE1_FK` FOREIGN KEY (`LANG_ID`) REFERENCES `I18nLanguageCountry` (`LANG_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `I18nMessage`;
CREATE TABLE `I18nMessage` (`MESSAGE_ID` bigint(19) NOT NULL default '0', `MESSAGE_KEY` varchar(255) NOT NULL default '', `MESSAGE_STRING` text NOT NULL, `MODULE_NAME` varchar(150) default NULL, `DESCRIPTION` varchar(255) default NULL, PRIMARY KEY  (`MESSAGE_ID`)) ENGINE=InnoDB; 

DROP TABLE IF EXISTS `I18nLocalMsg`;
CREATE TABLE `I18nLocalMsg` (`LOCALMSG_ID` bigint(19) NOT NULL default '0', `LOCALE_ID` bigint(19) NOT NULL default '0', `MESSAGE_ID` bigint(19) NOT NULL default '0', `LOCALMSG_STRING` text NOT NULL, PRIMARY KEY  (`LOCALMSG_ID`), KEY `I18NLOCALMSG1_FK_IDX` (`LOCALE_ID`), KEY `I18NLOCALMSG2_FK_IDX` (`MESSAGE_ID`), CONSTRAINT `I18NLOCALMSG1_FK` FOREIGN KEY (`LOCALE_ID`) REFERENCES `I18nLocale` (`LOCALE_ID`) ON DELETE CASCADE, CONSTRAINT `I18NLOCALMSG2_FK` FOREIGN KEY (`MESSAGE_ID`) REFERENCES `I18nMessage` (`MESSAGE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `I18nTranslator`;
CREATE TABLE `I18nTranslator` (`TRANSLATOR_ID` bigint(19) NOT NULL default '0', `DISPLAYNAME` varchar(150) default NULL, `USERNAME` varchar(150) NOT NULL default '', `EMAIL` varchar(150) default NULL, PRIMARY KEY  (`TRANSLATOR_ID`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `I18nCreatedBy`;
CREATE TABLE `I18nCreatedBy` (`LOCALE_ID` bigint(19) NOT NULL default '0', `TRANSLATOR_ID` bigint(19) NOT NULL default '0', `DESCRIPTION` varchar(255) default NULL, PRIMARY KEY  (`LOCALE_ID`,`TRANSLATOR_ID`), KEY `I18NCREATEDBY1_FK_IDX` (`LOCALE_ID`), KEY `I18NCREATEDBY2_FK_IDX` (`TRANSLATOR_ID`), CONSTRAINT `I18NCREATEDBY1_FK` FOREIGN KEY (`LOCALE_ID`) REFERENCES `I18nLocale` (`LOCALE_ID`) ON DELETE CASCADE, CONSTRAINT `I18NCREATEDBY2_FK` FOREIGN KEY (`TRANSLATOR_ID`) REFERENCES `I18nTranslator` (`TRANSLATOR_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `I18nCurrUserLocale`;
CREATE TABLE `I18nCurrUserLocale` (`LOCALE_ID` bigint(19) NOT NULL default '0', `TRANSLATOR_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`LOCALE_ID`,`TRANSLATOR_ID`), KEY `I18NCURRUSERLOCALE1_FK_IDX` (`LOCALE_ID`), KEY `I18NCURRUSERLOCALE2_FK_IDX` (`TRANSLATOR_ID`), CONSTRAINT `I18NCURRUSERLOCALE1_FK` FOREIGN KEY (`LOCALE_ID`) REFERENCES `I18nLocale` (`LOCALE_ID`) ON DELETE CASCADE, CONSTRAINT `I18NCURRUSERLOCALE2_FK` FOREIGN KEY (`TRANSLATOR_ID`) REFERENCES `I18nTranslator` (`TRANSLATOR_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `I18nPublicLocalMsg`;
CREATE TABLE `I18nPublicLocalMsg` (`PUBLICLOCALMSG_ID` bigint(19) NOT NULL default '0', `LOCALE_ID` bigint(19) NOT NULL default '0', `MESSAGE_ID` bigint(19) NOT NULL default '0', `PUBLICLOCALMSG_STRING` text NOT NULL, PRIMARY KEY  (`PUBLICLOCALMSG_ID`), KEY `I18NPUBLICLOCALMSG1_FK_IDX` (`LOCALE_ID`), KEY `I18NPUBLICLOCALMSG2_FK_IDX` (`MESSAGE_ID`), CONSTRAINT `I18NPUBLICLOCALMSG1_FK` FOREIGN KEY (`LOCALE_ID`) REFERENCES `I18nLocale` (`LOCALE_ID`) ON DELETE CASCADE, CONSTRAINT `I18NPUBLICLOCALMSG2_FK` FOREIGN KEY (`MESSAGE_ID`) REFERENCES `I18nMessage` (`MESSAGE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

-- CustomView Changes

------ All FKs are dropped first other the PK definition changes would be restricted by referring FKs.
ALTER TABLE `CustomViewConfiguration` DROP FOREIGN KEY `CV_CR_FK`;
ALTER TABLE `CustomViewConfiguration` DROP INDEX `CV_CR_FK_IDX`;
ALTER TABLE `ModeSpecificServiceProviders` DROP FOREIGN KEY `MSSPs_CVSP_FK`;
ALTER TABLE `ModeSpecificServiceProviders` DROP INDEX `MSSPs_CVSP_FK_IDX`;
ALTER TABLE `ClientServiceProviders` DROP FOREIGN KEY `ClientSP_MSSP_FK`;
ALTER TABLE `ClientServiceProviders` DROP INDEX `ClientSP_MSSP_FK_IDX`;
ALTER TABLE `ServerServiceProviders` DROP FOREIGN KEY `ServerSP_MSSP_FK`;
ALTER TABLE `ServerServiceProviders` DROP INDEX `ServerSP_MSSP_FK_IDX`;
ALTER TABLE `TreeDefinition` DROP FOREIGN KEY `TreeDef_CR_FK`;
ALTER TABLE `TreeDefinition` DROP INDEX `TreeDef_CR_FK_IDX`;
ALTER TABLE `TablesInTree` DROP FOREIGN KEY `TableInTree_TreeDef_FK`;
ALTER TABLE `TablesInTree` DROP INDEX `TableInTree_TreeDef_FK_IDX`;
ALTER TABLE `TreeIdentifierColumns` DROP FOREIGN KEY `TreeIdentifierCN_TreeDef_FK`;
ALTER TABLE `TreeIdentifierColumns` DROP INDEX `TreeIdentifierCN_TreeDef_FK_IDX`;
ALTER TABLE `TableViewSortColumn` DROP FOREIGN KEY `TableViewSortCol_FK`;
ALTER TABLE `TableViewSortColumn` DROP INDEX `TableViewSortCol_FK_IDX`;



ALTER TABLE `CustomViewConfiguration` ADD `CVID` BIGINT;
-- Populate SeqGenCol CustomViewConfiguration, CVID, NULL, NULL, NULL
ALTER TABLE `CustomViewConfiguration` MODIFY `CVID` BIGINT NOT NULL;
ALTER TABLE `CustomViewConfiguration` DROP PRIMARY KEY;
ALTER TABLE `CustomViewConfiguration` ADD PRIMARY KEY (`CVID`);
ALTER TABLE `CustomViewConfiguration` DROP `CRID`;

ALTER TABLE `CustomViewServiceProviders` ADD `CVTYPEID` BIGINT;
-- Populate SeqGenCol CustomViewServiceProviders, CVTYPEID, NULL, NULL, NULL
ALTER TABLE `CustomViewServiceProviders` MODIFY `CVTYPEID` BIGINT NOT NULL;
ALTER TABLE `CustomViewServiceProviders` DROP PRIMARY KEY;
ALTER TABLE `CustomViewServiceProviders` ADD PRIMARY KEY (`CVTYPEID`);


ALTER TABLE `ModeSpecificServiceProviders` ADD `CVTYPEID` BIGINT;
-- Populate SeqGenCol ModeSpecificServiceProviders, CVTYPEID, CVTYPE, CustomViewServiceProviders, CVTYPEID
ALTER TABLE `ModeSpecificServiceProviders` MODIFY `CVTYPEID` BIGINT NOT NULL;
ALTER TABLE `ModeSpecificServiceProviders` DROP PRIMARY KEY;
ALTER TABLE `ModeSpecificServiceProviders` ADD PRIMARY KEY (`CVTYPEID`,`COMM_MODE`);
ALTER TABLE `ModeSpecificServiceProviders` ADD KEY `MSSPs_CVSP_FK_IDX` (`CVTYPEID`);
ALTER TABLE `ModeSpecificServiceProviders` ADD CONSTRAINT `MSSPs_CVSP_FK` FOREIGN KEY (`CVTYPEID`) REFERENCES `CustomViewServiceProviders` (`CVTYPEID`) ON DELETE CASCADE;

ALTER TABLE `ClientServiceProviders` ADD `CVTYPEID` BIGINT;
-- Populate SeqGenCol ClientServiceProviders, CVTYPEID, CVTYPE, CustomViewServiceProviders, CVTYPEID
ALTER TABLE `ClientServiceProviders` MODIFY `CVTYPEID` BIGINT NOT NULL;
ALTER TABLE `ClientServiceProviders` DROP PRIMARY KEY;
ALTER TABLE `ClientServiceProviders` ADD PRIMARY KEY (`CVTYPEID`,`COMM_MODE`,`SERVICEPROVIDER`);
ALTER TABLE `ClientServiceProviders` ADD KEY `ClientSP_MSSP_FK_IDX` (`CVTYPEID`,`COMM_MODE`);
ALTER TABLE `ClientServiceProviders` ADD CONSTRAINT `ClientSP_MSSP_FK` FOREIGN KEY (`CVTYPEID`, `COMM_MODE`) REFERENCES `ModeSpecificServiceProviders` (`CVTYPEID`, `COMM_MODE`) ON DELETE CASCADE;


ALTER TABLE `ServerServiceProviders` ADD `CVTYPEID` BIGINT;
-- Populate SeqGenCol ServerServiceProviders, CVTYPEID, CVTYPE, CustomViewServiceProviders, CVTYPEID
ALTER TABLE `ServerServiceProviders` MODIFY `CVTYPEID` BIGINT NOT NULL;
ALTER TABLE `ServerServiceProviders` DROP PRIMARY KEY;
ALTER TABLE `ServerServiceProviders` ADD PRIMARY KEY (`CVTYPEID`,`COMM_MODE`,`SERVICEPROVIDER`);
ALTER TABLE `ServerServiceProviders` ADD KEY `ServerSP_MSSP_FK_IDX` (`CVTYPEID`,`COMM_MODE`);
ALTER TABLE `ServerServiceProviders` ADD CONSTRAINT `ServerSP_MSSP_FK` FOREIGN KEY (`CVTYPEID`, `COMM_MODE`) REFERENCES `ModeSpecificServiceProviders` (`CVTYPEID`, `COMM_MODE`) ON DELETE CASCADE;

ALTER TABLE `ModeSpecificServiceProviders` DROP `CVTYPE`;
ALTER TABLE `ClientServiceProviders` DROP `CVTYPE`;
ALTER TABLE `ServerServiceProviders` DROP `CVTYPE`;

ALTER TABLE `TreeDefinition` ADD `TREEID` BIGINT;
-- Populate SeqGenCol TreeDefinition, TREEID, NULL, NULL, NULL
ALTER TABLE `TreeDefinition` MODIFY `TREEID` BIGINT NOT NULL;
ALTER TABLE `TreeDefinition` DROP PRIMARY KEY;
ALTER TABLE `TreeDefinition` ADD  PRIMARY KEY(`TREEID`);
ALTER TABLE `TreeDefinition` DROP `CRID`;

ALTER TABLE `TablesInTree` ADD `TREEID` BIGINT;
-- Populate SeqGenCol TablesInTree, TREEID, TREETYPE, TreeDefinition, TREEID
ALTER TABLE `TablesInTree` MODIFY `TREEID` BIGINT NOT NULL;
ALTER TABLE `TablesInTree` DROP PRIMARY KEY;
ALTER TABLE `TablesInTree` ADD PRIMARY KEY (`TREEID`,`TREENODETABLE`,`TABLENAME`);
ALTER TABLE `TablesInTree` ADD KEY `TableInTree_TreeDef_FK_IDX` (`TREEID`);
ALTER TABLE `TablesInTree` ADD CONSTRAINT `TableInTree_TreeDef_FK` FOREIGN KEY (`TREEID`) REFERENCES `TreeDefinition` (`TREEID`) ON DELETE CASCADE;

ALTER TABLE `TreeIdentifierColumns` ADD `TREEID` BIGINT;
-- Populate SeqGenCol TreeIdentifierColumns, TREEID, TREETYPE, TreeDefinition, TREEID
ALTER TABLE `TreeIdentifierColumns` MODIFY `TREEID` BIGINT NOT NULL;
ALTER TABLE `TreeIdentifierColumns` DROP PRIMARY KEY;
ALTER TABLE `TreeIdentifierColumns` ADD PRIMARY KEY (`TREEID`,`COLUMNNAME`);
ALTER TABLE `TreeIdentifierColumns` ADD KEY `TreeIdentifierCN_TreeDef_FK_IDX` (`TREEID`);
ALTER TABLE `TreeIdentifierColumns` ADD CONSTRAINT `TreeIdentifierCN_TreeDef_FK` FOREIGN KEY (`TREEID`) REFERENCES `TreeDefinition` (`TREEID`) ON DELETE CASCADE;

ALTER TABLE `TableViewSortColumn` ADD `CVID` bigint(19);
-- Populate SeqGenCol TableViewSortColumn, CVID, CVNAME, CustomViewConfiguration, CVID
ALTER TABLE `TableViewSortColumn` MODIFY `CVID` bigint(19) NOT NULL;
ALTER TABLE `TableViewSortColumn` DROP PRIMARY KEY;
ALTER TABLE `TableViewSortColumn` ADD PRIMARY KEY (`CVID`);
ALTER TABLE `TableViewSortColumn` ADD KEY `TableViewSortCol_FK_IDX` (`CVID`);
ALTER TABLE `TableViewSortColumn` ADD CONSTRAINT `TableViewSortCol_FK` FOREIGN KEY (`CVID`) REFERENCES `CustomViewConfiguration` (`CVID`) ON DELETE CASCADE;

--DROP TABLE IF EXISTS `TableViewSortColumn`;
--CREATE TABLE `TableViewSortColumn` (`CVID` bigint(19) NOT NULL default '0', `TABLEALIAS` varchar(100) NOT NULL default '', `COLUMNNAME` varchar(100) NOT NULL default '', `ASCENDING_ORDER` tinyint(1) default NULL, `SORTINDEX` int(10) NOT NULL default '0', PRIMARY KEY  (`CVID`,`SORTINDEX`), KEY `TableViewSortCol_FK_IDX` (`CVID`), CONSTRAINT `TableViewSortCol_FK` FOREIGN KEY (`CVID`) REFERENCES `CustomViewConfiguration` (`CVID`) ON DELETE CASCADE) ENGINE=InnoDB;

-- User Management and Authentication Changes
DROP TABLE IF EXISTS `AaaModuleService`;
CREATE TABLE `AaaModuleService` (`ID` bigint(19) NOT NULL default '0', `MODULE_ID` bigint(19) default NULL, `SERVICE_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`ID`), KEY `AaaModuleService_FK1_IDX` (`MODULE_ID`), KEY `AaaModuleService_FK2_IDX` (`SERVICE_ID`), CONSTRAINT `AaaModuleService_FK1` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE, CONSTRAINT `AaaModuleService_FK2` FOREIGN KEY (`SERVICE_ID`) REFERENCES `AaaService` (`SERVICE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `AaaPamModule` ADD `DUMMYCOL` INTEGER DEFAULT 0;

ALTER TABLE `AaaPamModule` DROP `DUMMYCOL`;

DELETE FROM `AaaPamModule`;

ALTER TABLE `AaaPamConf` ADD `EXECORDER` INTEGER DEFAULT 0;

ALTER TABLE `AaaAccBadLoginStatus` ADD `HOST_NAME` varchar(200);

ALTER TABLE `AaaAccBadLoginStatus` DROP PRIMARY KEY;

ALTER TABLE `AaaAccBadLoginStatus` ADD CONSTRAINT PRIMARY KEY(ACCOUNT_ID, HOST, UPDATEDTIME);

ALTER TABLE `AaaAccSession` ADD `USER_HOST_NAME` varchar(200) NOT NULL;

ALTER TABLE `AaaUserConfigRecord` DROP FOREIGN KEY `AaaUserConfigRecord_FK2`;
ALTER TABLE `AaaUserConfigRecord` DROP INDEX `AaaUserConfigRecord_FK2_IDX`;
ALTER TABLE `AaaUserConfigRecord` DROP `CRID`;

DROP TABLE IF EXISTS `ActiveDirectoryInfo`;
CREATE TABLE `ActiveDirectoryInfo` (`AD_ID` bigint(19) NOT NULL default '0', `SERVERNAME` varchar(100) default NULL, `DEFAULTDOMAIN` varchar(50) default NULL, `USERNAME` varchar(50) default NULL, `PASSWORD` varchar(50) default NULL, PRIMARY KEY  (`AD_ID`)) ENGINE=InnoDB;

-- Authorization Changes
DROP TABLE IF EXISTS `AaaDisableAuth`;
CREATE TABLE `AaaDisableAuth` (`MODULE_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`MODULE_ID`), KEY `AaaDisableAuth_FK_IDX` (`MODULE_ID`), CONSTRAINT `AaaDisableAuth_FK` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

-- Audit Changes
ALTER TABLE `AuditConfig` ADD `MODULE_ID` BIGINT;

-- TaskEngine and WorkEngine Changes
DROP TABLE IF EXISTS `Workflow_Template_Task`;
CREATE TABLE `Workflow_Template_Task` (`TASK_ID` bigint(20) NOT NULL default '0', `TEMPLATE_ID` bigint(20) NOT NULL default '0', PRIMARY KEY  (`TASK_ID`), KEY `Workflow_Template_Task_FK1_IDX` (`TASK_ID`), KEY `Workflow_Template_Task_FK2_IDX` (`TEMPLATE_ID`), CONSTRAINT `Workflow_Template_Task_FK1` FOREIGN KEY (`TASK_ID`) REFERENCES `TaskEngine_Task` (`TASK_ID`) ON DELETE CASCADE, CONSTRAINT `Workflow_Template_Task_FK2` FOREIGN KEY (`TEMPLATE_ID`) REFERENCES `Workflow_Templates` (`WORKFLOW_TEMPLATE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `Workflow_Statements` DROP FOREIGN KEY `Workflow_Statements_FK3`;
ALTER TABLE `Workflow_Statements` DROP INDEX `Workflow_Statements_FK3_IDX`;
ALTER TABLE `Workflow_Statements` ADD  CONSTRAINT `Workflow_Statements_FK3` FOREIGN KEY (`NEXT_STATEMENT_ID`) REFERENCES `Statements` (`STATEMENT_ID`) ON DELETE SET NULL;

ALTER TABLE `Expressions` DROP FOREIGN KEY `Expressions_FK`;
ALTER TABLE `Expressions` DROP INDEX `Expressions_FK_IDX`;
ALTER TABLE `Expressions` DROP `CRID`;

DROP TABLE IF EXISTS `Integral_Expressions`;
CREATE TABLE `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Expressions_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), CONSTRAINT `Integral_Expressions_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Integral_Variables`;
CREATE TABLE `Integral_Variables` (`INTEGRAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', `RELVAR_ID` bigint(19) NOT NULL default '0', `ATTRIBUTE_NAME` varchar(100) NOT NULL default '', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Variables_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Variables_FK1_IDX` (`RELVAR_ID`), CONSTRAINT `Integral_Variables_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Integral_Variables_FK1` FOREIGN KEY (`RELVAR_ID`) REFERENCES `Relvars` (`RELVAR_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Decimal_Variables`;
CREATE TABLE `Decimal_Variables` (`DECIMAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', `RELVAR_ID` bigint(19) NOT NULL default '0', `ATTRIBUTE_NAME` varchar(100) NOT NULL default '', PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Variables_FK_IDX` (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Variables_FK1_IDX` (`RELVAR_ID`), CONSTRAINT `Decimal_Variables_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Decimal_Variables_FK1` FOREIGN KEY (`RELVAR_ID`) REFERENCES `Relvars` (`RELVAR_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Decimal_Agg_Vars`;
CREATE TABLE `Decimal_Agg_Vars` (`DECIMAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', `RELVAR_ID` bigint(19) NOT NULL default '0', `ATTRIBUTE_NAME` varchar(100) NOT NULL default '', `AGGREGATE_OPERATOR` int(10) NOT NULL default '0', PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Agg_Vars_FK_IDX` (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Agg_Vars_FK1_IDX` (`RELVAR_ID`), CONSTRAINT `Decimal_Agg_Vars_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Decimal_Agg_Vars_FK1` FOREIGN KEY (`RELVAR_ID`) REFERENCES `Relvars` (`RELVAR_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Integral_Template_Vars`;
CREATE TABLE `Integral_Template_Vars` (`INTEGRAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', `TEMPLATE_ID` bigint(20) NOT NULL default '0', `VARIABLE_NAME` varchar(100) NOT NULL default '', `INTEGRAL_INDEX` bigint(19) default NULL, PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Template_Vars_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Template_Vars_FK1_IDX` (`TEMPLATE_ID`,`VARIABLE_NAME`), KEY `Integral_Template_Vars_FK2_IDX` (`INTEGRAL_INDEX`), CONSTRAINT `Integral_Template_Vars_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Integral_Template_Vars_FK1` FOREIGN KEY (`TEMPLATE_ID`, `VARIABLE_NAME`) REFERENCES `Template_Data` (`TEMPLATE_ID`, `VARIABLE_NAME`) ON DELETE CASCADE, CONSTRAINT `Integral_Template_Vars_FK2` FOREIGN KEY (`INTEGRAL_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Decimal_Template_Vars`;
CREATE TABLE `Decimal_Template_Vars` (`DECIMAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', `TEMPLATE_ID` bigint(20) NOT NULL default '0', `VARIABLE_NAME` varchar(100) NOT NULL default '', `DECIMAL_INDEX` bigint(19) default NULL, PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Template_Vars_FK_IDX` (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Template_Vars_FK1_IDX` (`TEMPLATE_ID`,`VARIABLE_NAME`), KEY `Decimal_Template_Vars_FK2_IDX` (`DECIMAL_INDEX`), CONSTRAINT `Decimal_Template_Vars_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Decimal_Template_Vars_FK1` FOREIGN KEY (`TEMPLATE_ID`, `VARIABLE_NAME`) REFERENCES `Template_Data` (`TEMPLATE_ID`, `VARIABLE_NAME`) ON DELETE CASCADE, CONSTRAINT `Decimal_Template_Vars_FK2` FOREIGN KEY (`DECIMAL_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Int_Expr_Opr_Expr`;
CREATE TABLE `Int_Expr_Opr_Expr` (`INTEGRAL_EXPRESSION_ID` bigint(19) NOT NULL default '0', `LEFT_EXPRESSION_ID` bigint(19) NOT NULL default '0', `OPERATOR` int(10) NOT NULL default '0', `RIGHT_EXPRESSION_ID` bigint(19) default '0', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Expr_Opr_Expr_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Expr_Opr_Expr_FK1_IDX` (`LEFT_EXPRESSION_ID`), KEY `Int_Expr_Opr_Expr_FK2_IDX` (`RIGHT_EXPRESSION_ID`), CONSTRAINT `Int_Expr_Opr_Expr_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Int_Expr_Opr_Expr_FK1` FOREIGN KEY (`LEFT_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Int_Expr_Opr_Expr_FK2` FOREIGN KEY (`RIGHT_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Int_Expr_Opr_Const`;
CREATE TABLE `Int_Expr_Opr_Const` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `LEFT_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OPERATOR` int(20) NOT NULL default '0', `CONSTANT` bigint(20) NOT NULL default '0', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Expr_Opr_Const_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Expr_Opr_Const_FK1_IDX` (`LEFT_EXPRESSION_ID`), CONSTRAINT `Int_Expr_Opr_Const_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` ( `INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Int_Expr_Opr_Const_FK1` FOREIGN KEY (`LEFT_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Num_Expr_Opr_Decimal`;
CREATE TABLE `Num_Expr_Opr_Decimal` (`NUMERIC_EXPRESSION_ID` bigint(20) NOT NULL default '0', `LEFT_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OPERATOR` int(20) NOT NULL default '0', `CONSTANT` double(20,2) NOT NULL default '0.00', PRIMARY KEY  (`NUMERIC_EXPRESSION_ID`), KEY `Num_Expr_Opr_Decimal_FK_IDX` (`NUMERIC_EXPRESSION_ID`), KEY `Num_Expr_Opr_Decimal_FK1_IDX` (`LEFT_EXPRESSION_ID`), CONSTRAINT `Num_Expr_Opr_Decimal_FK` FOREIGN KEY (`NUMERIC_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Num_Expr_Opr_Decimal_FK1` FOREIGN KEY (`LEFT_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Int_Const_Opr_Expr`;
CREATE TABLE `Int_Const_Opr_Expr` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `CONSTANT` bigint(20) NOT NULL default '0', `OPERATOR` int(20) NOT NULL default '0', `RIGHT_EXPRESSION_ID` bigint(20) default NULL, PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Const_Opr_Expr_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Const_Opr_Expr_FK1_IDX` (`RIGHT_EXPRESSION_ID`), CONSTRAINT `Int_Const_Opr_Expr_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Int_Const_Opr_Expr_FK1` FOREIGN KEY (`RIGHT_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Num_Decimal_Opr_Expr`;
CREATE TABLE `Num_Decimal_Opr_Expr` (`NUMERIC_EXPRESSION_ID` bigint(20) NOT NULL default '0', `CONSTANT` double(20,2) NOT NULL default '0.00', `OPERATOR` int(20) NOT NULL default '0', `RIGHT_EXPRESSION_ID` bigint(20) default NULL, PRIMARY KEY  (`NUMERIC_EXPRESSION_ID`), KEY `Num_Decimal_Opr_Expr_FK_IDX` (`NUMERIC_EXPRESSION_ID`), KEY `Num_Decimal_Opr_Expr_FK1_IDX` (`RIGHT_EXPRESSION_ID`), CONSTRAINT `Num_Decimal_Opr_Expr_FK` FOREIGN KEY (`NUMERIC_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Num_Decimal_Opr_Expr_FK1` FOREIGN KEY (`RIGHT_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Int_Expr_To_Int`;
CREATE TABLE `Int_Expr_To_Int` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `EXPRESSION_ID` bigint(20) NOT NULL default '0', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Expr_To_Int_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Expr_To_Int_FK1_IDX` (`EXPRESSION_ID`), CONSTRAINT `Int_Expr_To_Int_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Int_Expr_To_Int_FK1` FOREIGN KEY (`EXPRESSION_ID`) REFERENCES `Expressions` (`EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Decimal_Expr_To_Dc`;
CREATE TABLE `Decimal_Expr_To_Dc` (`DECIMAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `EXPRESSION_ID` bigint(20) NOT NULL default '0', PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Expr_To_Dc_FK_IDX` (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Expr_To_Dc_FK1_IDX` (`EXPRESSION_ID`), CONSTRAINT `Decimal_Expr_To_Dc_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Decimal_Expr_To_Dc_FK1` FOREIGN KEY (`EXPRESSION_ID`) REFERENCES `Expressions` (`EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Int_DataObj_Expr`;
CREATE TABLE `Int_DataObj_Expr` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OBJECT_NAME` varchar(150) NOT NULL default '', `TABLE_NAME` varchar(150) default NULL, `COLUMN_NAME` varchar(150) default NULL, `IS_ORIGINAL` tinyint(1) NOT NULL default '0', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Int_DataObj_Expr_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), CONSTRAINT `Int_DataObj_Expr_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Decimal_DataObj_Expr`;
CREATE TABLE `Decimal_DataObj_Expr` (`DECIMAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OBJECT_NAME` varchar(150) NOT NULL default '', `TABLE_NAME` varchar(150) default NULL, `COLUMN_NAME` varchar(150) default NULL, `IS_ORIGINAL` tinyint(1) NOT NULL default '0', PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_DataObj_Expr_FK_IDX` (`DECIMAL_EXPRESSION_ID`), CONSTRAINT `Decimal_DataObj_Expr_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `String_Template_Vars` DROP FOREIGN KEY `String_Template_Vars_FK2`;
ALTER TABLE `String_Template_Vars` DROP INDEX `String_Template_Vars_FK2_IDX`;
ALTER TABLE `String_Template_Vars` ADD  CONSTRAINT `String_Template_Vars_FK2`FOREIGN KEY (`STRING_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;

DROP TABLE IF EXISTS `Str_Deriv_Int_Vars`;
CREATE TABLE `Str_Deriv_Int_Vars` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `LEFT_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OPERATOR` int(20) NOT NULL default '0', `RIGHT_EXPRESSION_ID` bigint(20) default NULL, PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Str_Deriv_Int_Vars_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Str_Deriv_Int_Vars_FK1_IDX` (`LEFT_EXPRESSION_ID`), KEY `Str_Deriv_Int_Vars_FK2_IDX` (`RIGHT_EXPRESSION_ID`), CONSTRAINT `Str_Deriv_Int_Vars_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Str_Deriv_Int_Vars_FK1` FOREIGN KEY (`LEFT_EXPRESSION_ID`) REFERENCES `String_Expressions` (`STRING_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Str_Deriv_Int_Vars_FK2` FOREIGN KEY (`RIGHT_EXPRESSION_ID`) REFERENCES `String_Expressions` (`STRING_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Int_Obj_Expr`;
CREATE TABLE `Int_Obj_Expr` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OBJECT_NAME` varchar(150) NOT NULL default '', `ATTRIBUTE_NAME` varchar(150) NOT NULL default '', `IS_HASHMAP` tinyint(1) NOT NULL default '0', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Int_Obj_Expr_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), CONSTRAINT `Int_Obj_Expr_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB; 

DROP TABLE IF EXISTS `Decimal_Obj_Expr`;
CREATE TABLE `Decimal_Obj_Expr` (`DECIMAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OBJECT_NAME` varchar(150) NOT NULL default '', `ATTRIBUTE_NAME` varchar(150) NOT NULL default '', `IS_HASHMAP` tinyint(1) NOT NULL default '0', PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_Obj_Expr_FK_IDX` (`DECIMAL_EXPRESSION_ID`), CONSTRAINT `Decimal_Obj_Expr_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `Time_Template_Vars` DROP FOREIGN KEY `Time_Template_Vars_FK2`;
ALTER TABLE `Time_Template_Vars` DROP INDEX `Time_Template_Vars_FK2_IDX`;
ALTER TABLE `Time_Template_Vars` ADD  CONSTRAINT `Time_Template_Vars_FK2` FOREIGN KEY (`TIME_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;

ALTER TABLE `Boolean_Template_Vars` DROP FOREIGN KEY `Boolean_Template_Vars_FK2`;
ALTER TABLE `Boolean_Template_Vars` DROP INDEX `Boolean_Template_Vars_FK2_IDX`;
ALTER TABLE `Boolean_Template_Vars` ADD  CONSTRAINT `Boolean_Template_Vars_FK2` FOREIGN KEY (`BOOLEAN_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;

DROP TABLE IF EXISTS `Bool_Num_Comp_Decimal`;
CREATE TABLE `Bool_Num_Comp_Decimal` (`BOOLEAN_EXPRESSION_ID` bigint(20) NOT NULL default '0', `LEFT_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OPERATOR` int(20) NOT NULL default '0', `CONSTANT` double(20,2) NOT NULL default '0.00', PRIMARY KEY  (`BOOLEAN_EXPRESSION_ID`), KEY `Bool_Num_Comp_Decimal_FK_IDX` (`BOOLEAN_EXPRESSION_ID`), KEY `Bool_Num_Comp_Decimal_FK1_IDX` (`LEFT_EXPRESSION_ID`), CONSTRAINT `Bool_Num_Comp_Decimal_FK` FOREIGN KEY (`BOOLEAN_EXPRESSION_ID`) REFERENCES `Boolean_Expressions` (`BOOLEAN_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Bool_Num_Comp_Decimal_FK1` FOREIGN KEY (`LEFT_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Bool_Decimal_Dataobj_Expr`;
CREATE TABLE `Bool_Decimal_Dataobj_Expr` (`BOOLEAN_EXPRESSION_ID` bigint(20) NOT NULL default '0', `NUMERIC_EXPRESSION_ID` bigint(20) NOT NULL default '0', `OPERATOR` int(20) NOT NULL default '0', `CONSTANT` double(20,2) NOT NULL default '0.00', PRIMARY KEY  (`BOOLEAN_EXPRESSION_ID`), KEY `Bool_Decimal_DataObj_FK_IDX` (`BOOLEAN_EXPRESSION_ID`), KEY `Bool_Decimal_DataObj_FK1_IDX` (`NUMERIC_EXPRESSION_ID`), CONSTRAINT `Bool_Decimal_DataObj_FK` FOREIGN KEY (`BOOLEAN_EXPRESSION_ID`) REFERENCES `Boolean_Expressions` (`BOOLEAN_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Bool_Decimal_DataObj_FK1` FOREIGN KEY (`NUMERIC_EXPRESSION_ID`) REFERENCES `Numeric_Expressions` (`NUMERIC_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `Update_Index_Vars` DROP FOREIGN KEY `Update_Index_Vars_FK2`;
ALTER TABLE `Update_Index_Vars` DROP INDEX `Update_Index_Vars_FK2_IDX`;
ALTER TABLE `Update_Index_Vars` ADD  CONSTRAINT `Update_Index_Vars_FK2` FOREIGN KEY (`VAR_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;

DROP TABLE IF EXISTS `Attachment_Input`;
CREATE TABLE `Attachment_Input` (`INPUT_ID` bigint(30) NOT NULL default '0', `FILE_PATH` varchar(150) NOT NULL default '', `FILE_TYPE` varchar(40) NOT NULL default 'No Type', PRIMARY KEY  (`INPUT_ID`,`FILE_PATH`), KEY `Attachment_Input_FK_IDX` (`INPUT_ID`), CONSTRAINT `Attachment_Input_FK` FOREIGN KEY (`INPUT_ID`) REFERENCES `Email_Task_Input` (`INPUT_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `Fk_Pointers` ADD `IS_POINTER_UNIQUE` tinyint(1) NOT NULL default '0';

ALTER TABLE `Periodic` ADD `EXECUTE_IMMEDIATELY` tinyint(1) NOT NULL default '0';

ALTER TABLE `Schedule` DROP FOREIGN KEY `Schedule_FK`;
ALTER TABLE `Schedule` DROP INDEX `Schedule_FK_IDX`;
ALTER TABLE `Schedule` DROP `CRID`;

DROP TABLE IF EXISTS `TaskEngine_Task`;
CREATE TABLE `TaskEngine_Task` (`TASK_ID` bigint(20) NOT NULL default '0', `TASK_NAME` varchar(250) NOT NULL default '', `CLASS_NAME` varchar(250) NOT NULL default '', PRIMARY KEY  (`TASK_ID`), UNIQUE KEY `TaskEngine_Task_UK0` (`TASK_NAME`)) ENGINE=InnoDB;
--INSERT INTO `TaskEngine_Task` SELECT TASK_TEMPLATE_ID, DESCRIPTION, CLASS_NAME FROM `Java_Api`;
INSERT INTO `TaskEngine_Task` SELECT TEMPLATE_ID, NAME, 'Dummy Class' FROM `Templates`;
-- Populate SeqGenCol TaskEngine_Task, CLASS_NAME, TASK_ID, Java_Api, CLASS_NAME, TASK_TEMPLATE_ID
----999--- Populate SeqGenCol TaskEngine_Task, TASK_ID, TASK_TEMPLATE_ID, Java_Api, TASK_TEMPLATE_ID

DROP TABLE IF EXISTS `Scheduled_Task`;
CREATE TABLE `Scheduled_Task` (`SCHEDULE_ID` bigint(20) NOT NULL default '0', `TASK_ID` bigint(20) NOT NULL default '0', `OFFSET` int(5) NOT NULL default '100', `SCHEDULE_MODE` int(2) NOT NULL default '2', `ADMIN_STATUS` int(2) NOT NULL default '3', `AUDIT_FLAG` tinyint(1) NOT NULL default '0', `TRANSACTION_TIME` int(20) NOT NULL default '0', `RETRY_SCHEDULE_ID` bigint(20) default NULL, `SKIP_MISSED_SCHEDULE` tinyint(1) NOT NULL default '0', `REMOVE_ON_EXPIRY` tinyint(1) NOT NULL default '0', PRIMARY KEY  (`SCHEDULE_ID`,`TASK_ID`), KEY `ScheduledTask_FK1_IDX` (`SCHEDULE_ID`), KEY `ScheduledTask_FK2_IDX` (`TASK_ID`), KEY `ScheduledTask_FK3_IDX` (`RETRY_SCHEDULE_ID`), CONSTRAINT `ScheduledTask_FK1` FOREIGN KEY (`SCHEDULE_ID`) REFERENCES `Schedule` (`SCHEDULE_ID`) ON DELETE CASCADE, CONSTRAINT `ScheduledTask_FK2` FOREIGN KEY (`TASK_ID`) REFERENCES `TaskEngine_Task` (`TASK_ID`) ON DELETE CASCADE, CONSTRAINT `ScheduledTask_FK3` FOREIGN KEY (`RETRY_SCHEDULE_ID`) REFERENCES `Schedule` (`SCHEDULE_ID`) ON DELETE CASCADE) ENGINE=InnoDB;
INSERT INTO `Scheduled_Task` SELECT SCHEDULE_ID, WORKFLOW_TEMPLATE_ID, OFFSET, SCHEDULE_MODE, ADMIN_STATUS, 0, TRANSACTION_TIME, -1, 0, 0 FROM Scheduled_WorkFlow;

ALTER TABLE `Task_Input` ADD `TASK_ID` bigint(20) NOT NULL default '0';
-- Populate SeqGenCol Task_Input, TASK_ID, WORKFLOW_TEMPLATE_ID, Java_Api, TASK_TEMPLATE_ID, TASK_TEMPLATE_ID
ALTER TABLE `Task_Input` ADD `IS_COMMISSIONED` tinyint(1) NOT NULL default '1';
ALTER TABLE `Task_Input` DROP FOREIGN KEY `Task_Input_FK1`;
ALTER TABLE `Task_Input` DROP INDEX `Task_Input_FK1_IDX`;
ALTER TABLE `Task_Input` ADD INDEX `Task_Input_FK1_IDX` (`SCHEDULE_ID`, `TASK_ID`);
ALTER TABLE `Task_Input` ADD  CONSTRAINT `Task_Input_FK1` FOREIGN KEY (`SCHEDULE_ID`, `TASK_ID`) REFERENCES `Scheduled_Task` (`SCHEDULE_ID`, `TASK_ID`) ON DELETE CASCADE;
ALTER TABLE `Task_Input` DROP FOREIGN KEY `Task_Input_FK2`;
ALTER TABLE `Task_Input` DROP INDEX `Task_Input_FK2_IDX`;
ALTER TABLE `Task_Input` DROP FOREIGN KEY `TaskInput_FK3`;
ALTER TABLE `Task_Input` DROP INDEX `TaskInput_FK3_IDX`;

ALTER TABLE `Default_Task_Input` MODIFY `VARIABLE_VALUE` text;
ALTER TABLE `Schedule_Audit` ADD `SCHEDULE_NAME` varchar(150) NOT NULL default '';
ALTER TABLE `Schedule_Audit` ADD `TASK_ID` bigint(20);
ALTER TABLE `Schedule_Audit` ADD `TASK_NAME` varchar(100) NOT NULL default '';
ALTER TABLE `Schedule_Audit` ADD `TASK_EXECUTION_STATUS` varchar(20) NOT NULL default '';

ALTER TABLE `Workflow_Unit` DROP FOREIGN KEY `Workflow_Unit_FK`;
ALTER TABLE `Workflow_Unit` DROP INDEX `Workflow_Unit_FK_IDX`;
ALTER TABLE `Workflow_Unit` DROP `CRID`;

ALTER TABLE `WorkEngine_Config` DROP FOREIGN KEY `WorkEngineConfig_FK`;
ALTER TABLE `WorkEngine_Config` DROP INDEX `WorkEngineConfig_FK_IDX`;
ALTER TABLE `WorkEngine_Config` DROP `CRID`;
ALTER TABLE `WorkEngine_Config` DROP `SCHEDULER_TYPE`;
ALTER TABLE `WorkEngine_Config` ADD INDEX `WorkEngineConfig_FK_IDX` (`MODULE_ID`);
ALTER TABLE `WorkEngine_Config` ADD CONSTRAINT `WorkEngineConfig_FK` FOREIGN KEY (`MODULE_ID`) REFERENCES `Module` (`MODULE_ID`) ON DELETE CASCADE;

DROP TABLE IF EXISTS `Working_Hours`;
CREATE TABLE `Working_Hours` (`WORKING_HOURS_ID` bigint(20) NOT NULL default '0', `START_TIME` bigint(20) NOT NULL default '0', `UNIT_OF_START_TIME` varchar(20) NOT NULL default '', `END_TIME` bigint(20) NOT NULL default '0', `UNIT_OF_END_TIME` varchar(20) NOT NULL default '', PRIMARY KEY  (`WORKING_HOURS_ID`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Calendar_Periodicity`;
CREATE TABLE `Calendar_Periodicity` (`SCHEDULE_ID` bigint(20) NOT NULL default '0', `WORKING_HOURS_ID` bigint(20) NOT NULL default '0', `PERIODICITY` bigint(20) NOT NULL default '1', `UNIT_OF_PERIODICITY` varchar(20) NOT NULL default 'hour', PRIMARY KEY  (`SCHEDULE_ID`), KEY `Calendar_Periodicity_FK1_IDX` (`SCHEDULE_ID`), KEY `Calendar_Periodicity_FK2_IDX` (`WORKING_HOURS_ID`), CONSTRAINT `Calendar_Periodicity_FK1` FOREIGN KEY (`SCHEDULE_ID`) REFERENCES `Calendar` (`SCHEDULE_ID`) ON DELETE CASCADE, CONSTRAINT `Calendar_Periodicity_FK2` FOREIGN KEY (`WORKING_HOURS_ID`) REFERENCES `Working_Hours` (`WORKING_HOURS_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

ALTER TABLE `Pattern_Template_Vars` DROP FOREIGN KEY `Pattern_Template_Vars_FK2`;
ALTER TABLE `Pattern_Template_Vars` DROP INDEX `Pattern_Template_Vars_FK2_IDX`;
ALTER TABLE `Pattern_Template_Vars` ADD  CONSTRAINT `Pattern_Template_Vars_FK2` FOREIGN KEY (`PATTERN_INDEX`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;
ALTER TABLE `Group_Count` ADD `INTEGRAL_EXPR_ID` bigint(20) NOT NULL default '0';
ALTER TABLE `Group_Count` DROP FOREIGN KEY `Group_Count_FK`;
ALTER TABLE `Group_Count` DROP INDEX `Group_Count_FK_IDX`;
ALTER TABLE `Group_Count` ADD  CONSTRAINT `Group_Count_FK` FOREIGN KEY (`INTEGRAL_EXPR_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;
ALTER TABLE `Start_End_Count` ADD `INTEGRAL_EXPR_ID` bigint(20) NOT NULL default '0';
ALTER TABLE `Start_End_Count` DROP FOREIGN KEY `Start_End_Count_FK`;
ALTER TABLE `Start_End_Count` DROP INDEX `Start_End_Count_FK_IDX`;
ALTER TABLE `Start_End_Count` ADD  CONSTRAINT `Start_End_Count_FK` FOREIGN KEY (`INTEGRAL_EXPR_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE;

DROP TABLE IF EXISTS `Integral_DataObj_Vars`;
CREATE TABLE `Integral_DataObj_Vars` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `TEMPLATE_ID` bigint(20) NOT NULL default '0', `VARIABLE_NAME` varchar(100) NOT NULL default '', `TABLE_NAME` varchar(100) NOT NULL default '', `TABLE_ARRAY_INDEX` int(10) NOT NULL default '-1', `COLUMN_NAME` varchar(240) NOT NULL default '', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_DataObj_Vars_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_DataObj_Vars_FK1_IDX` (`TEMPLATE_ID`,`VARIABLE_NAME`), CONSTRAINT `Integral_DataObj_Vars_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Integral_DataObj_Vars_FK1` FOREIGN KEY (`TEMPLATE_ID`, `VARIABLE_NAME`) REFERENCES `Template_Data` (`TEMPLATE_ID`, `VARIABLE_NAME`) ON DELETE CASCADE) ENGINE=InnoDB; 

DROP TABLE IF EXISTS `Decimal_DataObj_Vars`;
CREATE TABLE `Decimal_DataObj_Vars` (`DECIMAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `TEMPLATE_ID` bigint(20) NOT NULL default '0', `VARIABLE_NAME` varchar(100) NOT NULL default '', `TABLE_NAME` varchar(100) NOT NULL default '', `TABLE_ARRAY_INDEX` int(10) NOT NULL default '-1', `COLUMN_NAME` varchar(240) NOT NULL default '', PRIMARY KEY  (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_DataObj_Vars_FK_IDX` (`DECIMAL_EXPRESSION_ID`), KEY `Decimal_DataObj_Vars_FK1_IDX` (`TEMPLATE_ID`,`VARIABLE_NAME`), CONSTRAINT `Decimal_DataObj_Vars_FK` FOREIGN KEY (`DECIMAL_EXPRESSION_ID`) REFERENCES `Decimal_Expressions` (`DECIMAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Decimal_DataObj_Vars_FK1` FOREIGN KEY (`TEMPLATE_ID`, `VARIABLE_NAME`) REFERENCES `Template_Data` (`TEMPLATE_ID`, `VARIABLE_NAME`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Integral_Row_Count`;
CREATE TABLE `Integral_Row_Count` (`INTEGRAL_EXPRESSION_ID` bigint(20) NOT NULL default '0', `TEMPLATE_ID` bigint(20) NOT NULL default '0', `VARIABLE_NAME` varchar(100) NOT NULL default '', `TABLE_NAME` varchar(100) NOT NULL default '', PRIMARY KEY  (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Row_Count_FK_IDX` (`INTEGRAL_EXPRESSION_ID`), KEY `Integral_Row_Count_FK1_IDX` (`TEMPLATE_ID`,`VARIABLE_NAME`), CONSTRAINT `Integral_Row_Count_FK` FOREIGN KEY (`INTEGRAL_EXPRESSION_ID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE, CONSTRAINT `Integral_Row_Count_FK1` FOREIGN KEY (`TEMPLATE_ID`, `VARIABLE_NAME`) REFERENCES `Template_Data` (`TEMPLATE_ID`, `VARIABLE_NAME`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Trans_Closure_Operator`;
CREATE TABLE `Trans_Closure_Operator` (`VIEW_ID` bigint(20) NOT NULL default '0', `INPUT_RELVAR_ID` bigint(20) NOT NULL default '0', PRIMARY KEY  (`VIEW_ID`), KEY `Trans_Closure_Operator_FK_IDX` (`VIEW_ID`), KEY `Trans_Closure_Operator_FK1_IDX` (`INPUT_RELVAR_ID`), CONSTRAINT `Trans_Closure_Operator_FK` FOREIGN KEY (`VIEW_ID`) REFERENCES `Views` (`VIEW_ID`) ON DELETE CASCADE, CONSTRAINT `Trans_Closure_Operator_FK1` FOREIGN KEY (`INPUT_RELVAR_ID`) REFERENCES `Relvars` (`RELVAR_ID`) ON DELETE CASCADE) ENGINE=InnoDB; 

DROP TABLE IF EXISTS `Trans_Closure_Attributes`;
CREATE TABLE `Trans_Closure_Attributes` (`VIEW_ID` bigint(20) NOT NULL default '0', `SOURCE_ATTRIBUTE` varchar(40) NOT NULL default '', `DESTINATION_ATTRIBUTE` varchar(40) NOT NULL default '', PRIMARY KEY  (`VIEW_ID`), KEY `Trans_Closure_Attributes_FK_IDX` (`VIEW_ID`), CONSTRAINT `Trans_Closure_Attributes_FK` FOREIGN KEY (`VIEW_ID`) REFERENCES `Trans_Closure_Operator` (`VIEW_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Trans_Closure_Weights`;
CREATE TABLE `Trans_Closure_Weights` (`VIEW_ID` bigint(20) NOT NULL default '0', `WEIGHT_ATTRIBUTE` varchar(40) NOT NULL default '', `AGGREGATION_OPERATOR` int(20) NOT NULL default '0', `ALIASED_OUTPUT_NAME` varchar(40) NOT NULL default '', PRIMARY KEY  (`VIEW_ID`), KEY `Trans_Closure_Weights_FK_IDX` (`VIEW_ID`), CONSTRAINT `Trans_Closure_Weights_FK` FOREIGN KEY (`VIEW_ID`) REFERENCES `Trans_Closure_Operator` (`VIEW_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Trans_Closure_Weight_Expr`;
CREATE TABLE `Trans_Closure_Weight_Expr` (`VIEW_ID` bigint(20) NOT NULL default '0', `WEIGHT_ATTRIBUTE_EXPID` bigint(20) NOT NULL default '0', `AGGREGATION_OPERATOR` int(20) NOT NULL default '55', `ALIASED_OUTPUT_NAME` varchar(40) NOT NULL default '', PRIMARY KEY  (`VIEW_ID`), KEY `Trans_Closure_Weight_Expr_FK1_IDX` (`VIEW_ID`), KEY `Trans_Closure_Weight_Expr_FK2_IDX` (`WEIGHT_ATTRIBUTE_EXPID`), CONSTRAINT `Trans_Closure_Weight_Expr_FK1` FOREIGN KEY (`VIEW_ID`) REFERENCES `Trans_Closure_Operator` (`VIEW_ID`) ON DELETE CASCADE, CONSTRAINT `Trans_Closure_Weight_Expr_FK2` FOREIGN KEY (`WEIGHT_ATTRIBUTE_EXPID`) REFERENCES `Integral_Expressions` (`INTEGRAL_EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Relations`;
CREATE TABLE `Relations` (`RELATION_ID` bigint(20) NOT NULL default '0', `SOURCE_NODE` bigint(20) NOT NULL default '0', `DESTINATION_NODE` bigint(20) NOT NULL default '0', `RELATION_WEIGHT` int(10) NOT NULL default '1', PRIMARY KEY  (`RELATION_ID`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Paths`;
CREATE TABLE `Paths` (`PATH_ID` bigint(20) NOT NULL default '0', `PATH_SOURCE_NODE` bigint(20) NOT NULL default '0', `PATH_DESTINATION_NODE` bigint(20) NOT NULL default '0', `PATH_LENGTH` int(20) NOT NULL default '1', `PATH_WEIGHT` int(20) NOT NULL default '1', PRIMARY KEY  (`PATH_ID`)) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Relations_In_Path`;
CREATE TABLE `Relations_In_Path` (`PATH_ID` bigint(20) NOT NULL default '0', `RELATION_ID` bigint(20) NOT NULL default '0', `PATH_INDEX` int(20) NOT NULL default '0', PRIMARY KEY  (`PATH_ID`,`RELATION_ID`), KEY `Relations_In_Path_FK_IDX` (`PATH_ID`), KEY `Relations_In_Path_FK1_IDX` (`RELATION_ID`), CONSTRAINT `Relations_In_Path_FK` FOREIGN KEY (`PATH_ID`) REFERENCES `Paths` (`PATH_ID`) ON DELETE CASCADE, CONSTRAINT `Relations_In_Path_FK1` FOREIGN KEY (`RELATION_ID`) REFERENCES `Relations` (`RELATION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE IF EXISTS `Expressions_PIDX`;
CREATE TABLE `Expressions_PIDX` (`EXPRESSION_ID` bigint(19) NOT NULL, `TABLE_NAME` varchar(40) NOT NULL, PRIMARY KEY  (`EXPRESSION_ID`,`TABLE_NAME`), KEY `Expressions_PIDX_FK_IDX` (`EXPRESSION_ID`), CONSTRAINT `Expressions_PIDX_FK` FOREIGN KEY (`EXPRESSION_ID`) REFERENCES `Expressions` (`EXPRESSION_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

DROP TABLE `Workflow_Unit_PIDX`;
CREATE TABLE `Workflow_Unit_PIDX` (`WORKFLOW_UNIT_ID` bigint(20) NOT NULL, `TABLE_NAME` varchar(40) NOT NULL, PRIMARY KEY  (`WORKFLOW_UNIT_ID`,`TABLE_NAME`), KEY `Workflow_Unit_PIDX_FK_IDX` (`WORKFLOW_UNIT_ID`), CONSTRAINT `Workflow_Unit_PIDX_FK` FOREIGN KEY (`WORKFLOW_UNIT_ID`) REFERENCES `Workflow_Unit` (`WORKFLOW_UNIT_ID`) ON DELETE CASCADE) ENGINE=InnoDB;

-- LogAnalyzer DD Changes.

ALTER TABLE `ReportBuildingBlockGroup` DROP FOREIGN KEY `ReportBuildingBlockGroup_FK`;
ALTER TABLE `ReportBuildingBlockGroup` DROP INDEX `ReportBuildingBlockGroup_FK_IDX`;
ALTER TABLE `ReportBuildingBlockGroup` DROP `CRID`;

ALTER TABLE `Bookmark` DROP FOREIGN KEY `Bookmark_FK2`;
ALTER TABLE `Bookmark` DROP INDEX `Bookmark_FK2_IDX`;
ALTER TABLE `Bookmark` DROP `CRID`;

ALTER TABLE `Portlet` DROP FOREIGN KEY `Portlet_FK2`;
ALTER TABLE `Portlet` DROP INDEX `Portlet_FK2_IDX`;
ALTER TABLE `Portlet` DROP `CRID`;

