/**
 * $Id$
 */
var SmartCard = new function()
{
	var isLoadFirstTime = false;
	var smartCardStatus = false;
	var isFileUpdated = false;
	var certAttribute = "";
	var userAttribute = "";
	var ocspServerName = "";
	var ocspServerPort = 0;
	var linkedDomain = new Hashtable();
	var smartCardID = 0;
	var alertmsgHash = new Hashtable();

	var getLoadFirstTime = function(){
		return isLoadFirstTime;
	};
	var onDomainSelection = function(){
		var domainNameVal = "";
		$( "input[name='linkedDomainName']" ).each(function(){ 
			var isChecked = $( this ).prop('checked');
			if(isChecked) {
				var domainName = $( this ).attr('domainName');
				if(domainNameVal == ""){
					domainNameVal = domainName;
				}else{
					domainNameVal = domainNameVal + ", " + domainName;			
				}
			}
		});
		if(domainNameVal == ""){
			domainNameVal = $('#waadLinkedDomainsDiv').attr('domainDefault')
		}
		linkedDomain = new Hashtable();
		$( "input[name='linkedDomainName']" ).each(function(){ 
			var isChecked = $( this ).prop('checked');
			if(isChecked) {
				var domainName = $( this ).attr('domainName');
				var domainDN = $( this ).prop('distinguishedName');
				linkedDomain.put(domainName, domainName);
			}
		});
		$('#waadLinkedDomainsDiv').text(domainNameVal);	// NO I18N
	};
	var reinitUI = function(){
		$("#certAttribute").val("SAN.OtherName");
		$("#userAttribute").val("userPrincipalName");
		$("#ocspServerName").val("");
		$("#ocspServerPort").val("");
		$( "input[name='linkedDomainName']" ).each(function(){ 
			$( this ).prop('checked', false);
			
		});
		
		var domainNameVal = $('#waadLinkedDomainsDiv').attr('domainDefault')
		$('#waadLinkedDomainsDiv').text(domainNameVal);	// NO I18N
	}
	var initSmartCardDetails = function(){
		certAttribute = $("#certAttribute").val();
		userAttribute = $("#userAttribute").val();
		ocspServerName = $("#ocspServerName").val();
		ocspServerPort = $("#ocspServerPort").val();
		
	/*	linkedDomain = new Hashtable();
		$( "input[name='linkedDomainName']" ).each(function(){ 
			var isChecked = $( this ).prop('checked');
			if(isChecked) {
				var domainName = $( this ).attr('domainName');
				var domainDN = $( this ).prop('distinguishedName');
				linkedDomain.put(domainName, domainName);
			}
		});
		*/
	};
	var toJSONString = function(){
		var json = "{";
			json += "\"SMARTCARD_ID\":" + smartCardID + ","; 									//NO I18N
			json += "\"CRETIFICATE_MAPPING_ATTRIBUTE\":" + certAttribute + ","; 									//NO I18N
			json += "\"AD_MAPPING_ATTRIBUTE\":" + userAttribute + ","; 												//NO I18N
			if(ocspServerName == "") ocspServerName = "-";															//NO I18N
			json += "\"OCSP_SERVER_NAME\":" + ocspServerName + ","; 												//NO I18N
			if(ocspServerPort == "") ocspServerPort = 0;
			json += "\"OCSP_SERVER_PORT\":" + ocspServerPort + ","; 												//NO I18N
			json += "\"LINKED_DOMAINS\":" + linkedDomain.toJSONString(); 											//NO I18N
			json += "}";
		return json;
	};
	
	var showUpdateButton = function(){
		$('#smartCardUpdateButton').show();		$('#smartCardCancelButton').show();		
		$('#smartCardAddButton').hide();		$('#smartCardAddCAButton').hide();
		$('#cretFileUpload').hide();			$('#fileUpdate').show();
	};
	var showAddButton = function(){
		$('#smartCardAddButton').show();		$('#smartCardCancelButton').show();	
		$('#smartCardUpdateButton').hide();		$('#smartCardAddCAButton').hide();
		$('#cretFileUpload').show();			$('#fileUpdate').hide();
	};
	var hideAddSmartConfigurations = function(){
		$('#ConfiguredSmartCardCADiv').show();	$('#smartCardStatus').show();				// NO I18N
		$('#addEditSmartCardDiv').hide();		$('#smartCardAddCAButton').hide();
	};
	var displayAddSmartCardUI = function(action){
		$('#addEditSmartCardDiv').show();		$('#successMessage').hide();
		$('#ConfiguredSmartCardCADiv').hide();
		if(action == 'add'){
			linkedDomain = new Hashtable();
			reinitUI();
			showAddButton();
		}else{
			showUpdateButton();
		}
	};	
	var showAddCAConfigurations = function(){
		reinitUI();
		$('#smartCardAddCAButton').show();	$('#addEditSmartCardDiv').show();		$('#ConfiguredSmartCardCADiv').hide();		
		$('#smartCardAddButton').hide();		$('#smartCardUpdateButton').hide();
		$('#smartCardCancelButton').hide(); $('#smartCardStatus').hide();	// NO I18N
		$('#cretFileUpload').show();		$('#fileUpdate').hide();
	};
	var showDomainCallBackFunction = function(){		
		var domainListHTML = $('#domainSelectionList').html();//NO I18N
		$('#domainSelectionList').remove();//NO I18N
		$('#domainSelectionListOuterDiv').append($('<div>').attr('id', 'domainSelectionList'));	//NO I18N
		$('#domainSelectionList').append(domainListHTML);//NO I18N
	};
	var showDomainSelection = function() {
		var resultDivId = 'domainSelectionListOuterDiv';//NO I18N
		var srcDivId 	= 'waadLinkedDomainsDiv';//NO I18N
		var domainListHTML = docid(resultDivId).innerHTML;
		$('#domainSelectionList').remove();//NO I18N
		DialogBox.showDialog(domainListHTML, 'className=no, needIframe=no, position=relative, top=0, left=0, srcElement='+srcDivId+',  closeButton=no, closeOnBodyClick=yes', null,showDomainCallBackFunction);	    //NO I18N
		$( "input[name='linkedDomainName']" ).each(function(){ 
			var domainName = $( this ).attr('domainName');
			var isChecked = linkedDomain.get(domainName);
			if(isChecked != '') {
				$( this ).prop('checked', true);
			}
		});
	};	
	
	var redrawSmartCardConfigurationUI = function(isSmartCardConfigured, isSmartCardListEmpty){
		if(isSmartCardConfigured == "true"){
			$('#smartCardStatusEnabledDiv').show();		// NO I18N	
			$('#smartCardStatusDisabledDiv').hide();	// NO I18N
		
		}else{
			$('#smartCardStatusEnabledDiv').hide();		// NO I18N
			$('#smartCardStatusDisabledDiv').show();	// NO I18N
		}
		
		if( isSmartCardListEmpty == "true"){			
			SmartCard.showAddCAConfigurations();
		}
		else{
			SmartCard.hideAddSmartConfigurations();
		}
	};
	
	var toggleOCSPSetting = function(){
		$('#ocspServerDiv').toggle();
		var ocspClassName = $('#ocspSettingsDisplayStatus').attr('class');
		if(ocspClassName == 'sc-ocspSettingsdownArrow'){
			$('#ocspSettingsDisplayStatus').removeClass('sc-ocspSettingsdownArrow');
			$('#ocspSettingsDisplayStatus').addClass('sc-ocspSettingssideArrow');
		}
		else{
			$('#ocspSettingsDisplayStatus').removeClass('sc-ocspSettingssideArrow');
			$('#ocspSettingsDisplayStatus').addClass('sc-ocspSettingsdownArrow');			
		}		
	};
	var validateConfiguration = function(){
		var validTxt = "";

		var str = document.getElementById("cretFileUpload").value;
		if(str != "") {
			var checkFile = str.indexOf("cer");													//NO I18N
			var checkDot = str.split(".");
			if(checkDot == str) {
				validTxt = "ads_admin_smartcard_please_select_a_valid_certificate";					//NO I18N
			}
			if(!(checkFile  > -1)) {
				validTxt = "ads_admin_smartcard_please_select_a_valid_certificate";					//NO I18N
			}
		}
		if(str == ""){
			validTxt = "ads_admin_smartcard_please_import_root_ca_certificate";					//NO I18N
		}
		else if(validTxt == ""){
			validTxt = validateInputValues();
		}
		return validTxt;
	}
	
	var validateInputValues = function(){
		var validTxt = "";
		if(certAttribute == ""){
			validTxt = "ads_admin_smartcard_please_enter_certificate_mapping_attribute";					//NO I18N
		}
		else if(userAttribute == ""){
			validTxt = "ads_admin_smartcard_please_enter_ad_mapping_attribute";					//NO I18N
		}
		else if(linkedDomain.count == 0){
			validTxt = "ads_admin_smartcard_please_select_linked_domains";					//NO I18N
		}
		
		if(ocspServerPort != "" || ocspServerName != ""){
			if(ocspServerPort == ""){
				validTxt = "ads_admin_smartcard_please_enter_ocspServerPort";					//NO I18N
			}
			else if(ocspServerName == ""){
				validTxt = "ads_admin_smartcard_please_enter_ocspServerName";					//NO I18N
			}
			else if(ocspServerPort != ""){
				var isNumeric = $.isNumeric(ocspServerPort);
				if(isNumeric){
					if(ocspServerPort < 0){
						validTxt = "ads_admin_smartcard_please_enter_valid_port";					//NO I18N
					}
				}
				else{
					validTxt = "ads_admin_smartcard_please_enter_valid_port";						//NO I18N
				}
			}
		}		
		return validTxt;
	};	
	var addAlertmsgHash = function(key, keyVal){
		alertmsgHash.put(key, keyVal);
	};
	var addNewSmartConfigurations = function(){
		initSmartCardDetails();
		var validTxt = validateConfiguration();
		
		if(validTxt == ""){
			var params = toJSONString();
			$('#smartCardParams').val(params);
			$('#loadingDiv').show();
			
			hideAddSmartConfigurations();
			myForm.submit();
			isLoadFirstTime = true;
		}
		else{
			alert(alertmsgHash.get(validTxt));
		}
	};
	var showAddSmartCardSuccessDiv = function(action){
		var params = "actionType=ADD";																//NO I18N
		AjaxAPI.sendRequest({URL:"/SmartCard.do?methodToCall=showSmartCardConfiguredRows", PARAMETERS:params, ONSUCCESSFUNC:SmartCard.loadCurrentSmartDetailsRowsSuccess, ONFAILUREFUNC:showStatusFailure, ACTION:action});								 //NO I18N
		isLoadFirstTime = false;
	};	
	var deleteSmartCardDetails = function(uniqueID){
		var r = confirm(alertmsgHash.get("ads_admin_smartcard_please_alert_are_you_sure_want_to_delete_ca"));				//NO I18N
		if (r == true) {
			reinitUI();
			SmartCard.deleteSmartCard(uniqueID);
		}
	};	
	var deleteSmartCard = function(uniqueID){
		var action = "DELETE";					//No i18N
		var params = "uniqueId=" + uniqueID;	//No i18N
		AjaxAPI.sendRequest({URL:"/SmartCard.do?methodToCall=deleteSmartCardDetails", PARAMETERS:params, ONSUCCESSFUNC:SmartCard.loadCurrentSmartDetailsRowsSuccess, ONFAILUREFUNC:showStatusFailure, OPSTATUSID:"loadingDiv",	OPSTATUSTYPE:"", OPSTATUSMESSAGE: "Loading ...", OPSTATUSLOADINGCLASS: "sc-loadingmessage", OPSTATUSLOADEDCLASS: "sc-loadedmessage", ACTION:action});//No i18N
	};
	
	
	var editSmartCardDetails = function(uniqueID){		
		var params = "uniqueId=" + uniqueID;				//No i18N
		AjaxAPI.sendRequest({URL:"/SmartCard.do?methodToCall=getSmartCardConfiguration", PARAMETERS:params, ONSUCCESSFUNC:SmartCard.onEditSmardCardSuccess, ONFAILUREFUNC:showStatusFailure, OPSTATUSID:"loadingDiv",	OPSTATUSTYPE:"", OPSTATUSMESSAGE: "Loading ...", OPSTATUSLOADINGCLASS: "sc-loadingmessage", OPSTATUSLOADEDCLASS: "sc-loadedmessage"});//No i18N
	};
	var onEditSmardCardSuccess = function(response,requestOptions){
		var jsonText = response.responseText;
		var popupConfigObj = eval('('+jsonText+')');
				
		smartCardID = popupConfigObj.SMARTCARD_ID;
		
		$("#fileUpdate").val(popupConfigObj.CERTIFICATE_NAME);
		document.getElementById("fileUpdate").disabled = true;
		
		$("#certAttribute").val(popupConfigObj.CRETIFICATE_MAPPING_ATTRIBUTE);
		$("#userAttribute").val(popupConfigObj.AD_MAPPING_ATTRIBUTE);
		$("#ocspServerName").val(popupConfigObj.OCSP_SERVER_NAME);
		$("#ocspServerPort").val(popupConfigObj.OCSP_SERVER_PORT);
		var domainNameVal = "";
		var tabsList = new Array();
		linkedDomain = new Hashtable();
		for(var i=0;i < popupConfigObj.LINKED_DOMAINS.length; i++){
			tabsList[i] = popupConfigObj.LINKED_DOMAINS[i];
		}
		$( "input[name='linkedDomainName']" ).each(function(){ 
			var domainName = $( this ).attr('domainName');
			if(tabsList.contains(domainName)){
				$( this ).prop('checked', true);
				linkedDomain.put(domainName, domainName);
				if(domainNameVal == ""){
					domainNameVal = domainName;
				}else{
					domainNameVal = domainNameVal + ", " + domainName;			
				}
			}
		});
			
		if(domainNameVal == ""){
			domainNameVal = $('#waadLinkedDomainsDiv').attr('domainDefault')
		}
		$('#waadLinkedDomainsDiv').text(domainNameVal);	// NO I18N
		
		SmartCard.displayAddSmartCardUI('update');		// NO I18N
	};
	var updateSmartConfigurations = function(){
		initSmartCardDetails();
		
		var validTxt = validateInputValues();
		if(validTxt == ""){
			var params = toJSONString();
			AjaxAPI.sendRequest({URL:"/SmartCard.do?methodToCall=updateSmartCardConfiguration",PARAMETERS:"params="+params,ONSUCCESSFUNC: loadCurrentSmartDetailsRowsSuccess, ONFAILUREFUNC:showStatusFailure, OPSTATUSID:"loadingDiv",	OPSTATUSTYPE:"", OPSTATUSMESSAGE: "Loading ...", OPSTATUSLOADINGCLASS: "sc-loadingmessage", OPSTATUSLOADEDCLASS: "sc-loadedmessage"});			 		//NO I18N
		}
		else{
			alert(alertmsgHash.get(validTxt));
		}
	};
	
	var updateSmartCardStatus = function(obj){
		var params = "smartCardStatus=true";																//NO I18N
		var currentStatus = $(obj).attr('SCStatus');
		if(currentStatus == "ENABLED"){
			params = "smartCardStatus=false";																//NO I18N
		}			
		AjaxAPI.sendRequest({URL:"/SmartCard.do?methodToCall=updateSmartCardStatus", PARAMETERS:params, ONSUCCESSFUNC:loadCurrentSmartDetailsRowsSuccess, ONFAILUREFUNC:showStatusFailure});								 //NO I18N
	};
	
	var loadCurrentSmartDetailsRowsSuccess = function(response, requestOptions){
		$('#smartCardDetailsRowsDiv').empty();
		$('#smartCardDetailsRowsDiv').html(response.responseText);				//NO I18N
		
		var successMessageHTML = $('#statusMessageDiv').html();					//NO I18N
		$('#statusMessageDiv').remove(); 					//NO I18N
		$('#successMessage').empty();			 			//NO I18N
		$('#successMessage').append(successMessageHTML);	//NO I18N
		$('#successMessage').show();						//NO I18N
		$('#loadingDiv').hide();
	};
	var showStatusFailure = function(){	};
	
	
	return{
		getLoadFirstTime : getLoadFirstTime,
		onDomainSelection : onDomainSelection,
		reinitUI : reinitUI,

		showDomainSelection : showDomainSelection,
		redrawSmartCardConfigurationUI : redrawSmartCardConfigurationUI,
		showAddCAConfigurations : showAddCAConfigurations,
		displayAddSmartCardUI : displayAddSmartCardUI,
		hideAddSmartConfigurations : hideAddSmartConfigurations,
		toggleOCSPSetting : toggleOCSPSetting,
		

		addAlertmsgHash : addAlertmsgHash,					
		addNewSmartConfigurations : addNewSmartConfigurations,						// Add CA to Trust Store
		showAddSmartCardSuccessDiv : showAddSmartCardSuccessDiv,					// Loads New with Status 
		deleteSmartCardDetails : deleteSmartCardDetails,							// Remove CA from Trust Store
		deleteSmartCard : deleteSmartCard,											// Remove CA from Trust Store
		editSmartCardDetails : editSmartCardDetails,								// Gets configured CA Values from DB
		onEditSmardCardSuccess : onEditSmardCardSuccess,							// Success Function to fill UI Values
		updateSmartConfigurations : updateSmartConfigurations,						// Edit to Attribute Mapping Trust Store
		updateSmartCardStatus : updateSmartCardStatus,								// ENABLE/DISABLE SmartCard Support 
		
		loadCurrentSmartDetailsRowsSuccess : loadCurrentSmartDetailsRowsSuccess	//Common Method for all the CRUD Action To Show Success Message
	};
	
}();