/*
 * $Id$
 */
var TwoFactorAuthentication = new function(){
	var tfaModeId = 0;									// private variable 
	var tfaModeParamsHash = new Hashtable();		 	// private variable 
	var isTFAEnabled = false;
	var tfaStatusParams = "";
	
	var getTFAEnabled = function() 				{	return isTFAEnabled; 	};
	var setTFAEnabled = function(isTFAEnabled) 	{	isTFAEnabled = isTFAEnabled;	};
	
	var getTFAModeId = function() 		{	return tfaModeId; 	};
	var setTFAModeId = function(modeId) {	tfaModeId = modeId;	};
	var txtPosition = -1;
	
	
// Methods to list all the supported TFA STARTS here
	var showSupportedTFAList = function() {
		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=showSupportedTFAList", ONSUCCESSFUNC:showSupportedTFAListSuccessDiv, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
	};
	var showSupportedTFAListSuccessDiv = function(response, requestOptions) {
		document.getElementById('TFAConfigDiv').innerHTML = response.responseText;							//No I18N
		$('#TFAConfigDiv').show("slow");																	//No I18N
	};
	var showSupportedTFAListFailure = function(){
		DialogBox.alert("ads_admin_tfa_settings_alert_failure_msg");//NO I18N
	};
// Methods to list all the supported TFA ENDS here	

	
// Methods to Manage TFA Mode status update here
	var updateModeTFAStatus = function(obj, e){		
		if (window.event) event.cancelBubble=true;
		else if (e.stopPropagation) e.stopPropagation();
		
		if(isTFAEnabled){
			var modeId = $(obj).attr('modeId');
			var modeName = $(obj).attr('modeName');
			var status = $(obj).attr('status');
			tfaStatusParams = "updateStatus="+status+"&modeId="+modeId;										//NO I18N
			
			if(status == 'ENABLED'){
				var modeDisableErrMsg = "ads_admin_tfa_settings_r_u_sure_to_disable_tfa_to_configure";//NO I18N
				if(modeName == 'TFA_DUO_AUTHENTICATOR'){
					modeDisableErrMsg = "ads_admin_tfa_settings_r_u_sure_to_disable_duo_security";//NO I18N
				}
				else if(modeName == 'TFA_GOOGLE_AUTHENTICATOR'){
					modeDisableErrMsg = "ads_admin_tfa_settings_r_u_sure_to_disable_google_authenticator";//NO I18N
				}
				else if(modeName == 'TFA_MAIL_AUTHENTICATOR'){
					modeDisableErrMsg = "ads_admin_tfa_settings_r_u_sure_to_disable_otp_via_email";//NO I18N
				}
				else if(modeName == 'TFA_RSA_AUTHENTICATOR'){
   					modeDisableErrMsg = "ads_admin_tfa_settings_r_u_sure_to_disable_rsa_authenticator";//NO I18N
   				}
				DialogBox.confirm(modeDisableErrMsg, "TwoFactorAuthentication.updateModeTFAStatusCallBack");//NO I18N
			}
			else
			{
				DialogBox.alert("ads_admin_tfa_settings_please_save_tfa_configuration_to_enable_tfa_mode");//NO I18N
			}
		}
		else{
			DialogBox.alert("ads_admin_tfa_settings_please_enable_tfa_to_configure");//NO I18N
		}
	};
	var updateModeTFAStatusCallBack = function(){
		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=updateTFAModeStatus", PARAMETERS:tfaStatusParams, ONSUCCESSFUNC:loadTFAStatusSuccess, ONFAILUREFUNC:showSupportedTFAListFailure});				//NO I18N
	}
// Methods to Manage TFA Mode status ends here	


// Methods to Manage TFA status starts here	
	var updateTFAStatus = function(obj){
		var isEnabled = $('#TFAStatus').attr('isEnabled');
		var params = "updateStatus="+isEnabled;															//NO I18N

		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=updateStatus", PARAMETERS:params, ONSUCCESSFUNC:loadTFAStatusSuccess, ONFAILUREFUNC:showSupportedTFAListFailure});								 //NO I18N
	};	
	var loadTFAStatusSuccess = function(response, requestOptions){
		document.getElementById('statusMessageDiv').innerHTML = response.responseText;						//No I18N
		$('#statusMessageDiv').show();																		//No I18N
	};
	var setTFAStatusUI = function(tfaStatus, isSuccessfullUpdate){
		if(tfaStatus == "true"){
			$(".switch span").css("background-color", "#4bd663");
			$(".switch span i").css("left", "14px");
			$(".switch .green").css("display", "block");
			$(".switch .gray").css("display", "none");
			$('#TFAStatus').attr('isEnabled', 'true');
			$('#TfaAccordionDiv').hide();
			isTFAEnabled = true;
		}
		else{
			$(".switch span").css("background-color", "#ccc");
			$(".switch span i").css("left", "0px");
			$(".switch .green").css("display", "none");
			$(".switch .gray").css("display", "block");
			$('#TFAStatus').attr('isEnabled', 'false');
			$('#TfaAccordionDiv').show();
			isTFAEnabled = false;
		}
		
		if(isSuccessfullUpdate == "true"){
			showSupportedTFAList();			
		}
		setTimeout(hideStatusDiv, 3000);
	};
	var hideStatusDiv = function(){
		$('#statusMessageDiv').hide();																		//No I18N
	};
// Methods to Manage TFA status ends here	


//Methods to Manage TFA status starts here
	var validateInput = function(modeName){
		if(modeName == 'TFA_DUO_AUTHENTICATOR'){
			if($('#I_KEY').val() == "" || $('#S_KEY').val() == "" || $('#API_HOST_NAME').val() == ""){
				DialogBox.alert("ads_admin_tfa_settings_please_provide_valid_duo_details");//NO I18N
				return false;
			}
		}
		else if(modeName == 'TFA_RSA_AUTHENTICATOR'){
			var hasSDConf = $('#IS_RSA_ENABLED').attr('hassdconf');
			if(hasSDConf != "true"){
				DialogBox.alert("ads_admin_tfa_settings_provide_rsa_agent");//NO I18N
				return false;
			}
		}
		else if(modeName == 'TFA_MAIL_AUTHENTICATOR'){
			if($('#SUBJECT').val() == "" || $('#MESSAGE').val() == ""){
				DialogBox.alert("ads_admin_tfa_settings_please_provide_valid_mail_authenticator");//NO I18N
				return false;
			}
			if($('#SUBJECT').val().length > 999){
				DialogBox.alert("ads_admin_tfa_settings_please_enter_a_smaller_subject");//NO I18N
				return false;
			}
			if($('#MESSAGE').val().length > 999){
				DialogBox.alert("ads_admin_tfa_settings_please_enter_a_smaller_message");//NO I18N
				return false;
			}
			var messageValue = $('#MESSAGE').val();
			if(messageValue.indexOf('%confirmCode%') == -1)
			{
				DialogBox.alert("ads_admin_tfa_settings_confirmCodeisManadatory");//NO I18N
				return false;
			}
		}
		return true;
	};
	var getJSONString = function(modeId, modeName){
		var json = "{";
		if(modeName == 'TFA_DUO_AUTHENTICATOR'){
			json += "\"I_KEY\":"+ FcEscapeUtil.getEncodedJSONStringWithQuotes($('#I_KEY').val())+","; 				//NO I18N
			json += "\"S_KEY\":"+ FcEscapeUtil.getEncodedJSONStringWithQuotes($('#S_KEY').val())+","; 				//NO I18N
			json += "\"API_HOST_NAME\":"+ FcEscapeUtil.getEncodedJSONStringWithQuotes($('#API_HOST_NAME').val())+",";	//NO I18N
		}
		else if(modeName == 'TFA_GOOGLE_AUTHENTICATOR'){
			var isEnabled = $('#IS_ENABLED').prop("checked");
			json += "\"IS_ENABLED\":"+ isEnabled+","; 				//NO I18N
		}
		else if(modeName == 'TFA_MAIL_AUTHENTICATOR'){
			json += "\"SUBJECT\":"+ FcEscapeUtil.getEncodedJSONStringWithQuotes($('#SUBJECT').val())+","; 			//NO I18N
			json += "\"MESSAGE\":"+ FcEscapeUtil.getEncodedJSONStringWithQuotes($('#MESSAGE').val())+","; 				//NO I18N
		}
		else if(modeName == 'TFA_RSA_AUTHENTICATOR'){
			var isEnabled = $('#IS_RSA_ENABLED').prop("checked");
			json += "\"IS_RSA_ENABLED\":"+ isEnabled+","; 				//NO I18N
		}

		json += "\"MODE_NAME\":" + modeName +","; 				//NO I18N
		json += "\"MODE_ID\":"+ modeId; 				//NO I18N
		json +="}";
		return json;
	};
	var saveTFAConfiguration = function(obj){
		var modeId = $(obj).attr('modeId');
		var modeName = $('#accordion_'+modeId).attr('modeName');
		if(isTFAEnabled){
			if(!validateInput(modeName)) return;
			var params = getJSONString(modeId, modeName);
			AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=saveTFAConfiguration", PARAMETERS:"params="+params, ONSUCCESSFUNC: loadTFAStatusSuccess, ONFAILUREFUNC:showSupportedTFAListFailure}); //NO I18N
		}
		else{
			DialogBox.alert("ads_admin_tfa_settings_please_enable_tfa_to_configure");//NO I18N
		}
	};
	var toggleModeConfiguration = function(obj) {
		var modeId = $(obj).attr('modeId');		
		if(!$('#accordion_'+modeId).hasClass("accordion-section-selected")){
			$('div[id^=accordion_]').removeClass("accordion-section-selected");
			$('#accordion_'+modeId).addClass("accordion-section-selected");
			$('div[id^=help_links_div]').hide();		//Hides all help Links
			$('#help_links_div'+modeId).show();			//Shows selected TFA
		}
		else{
			$('#accordion_'+modeId).removeClass("accordion-section-selected");
			$('div[id^=help_links_div]').hide();		//Hides all help Links
			$('#help_links_div_default').show();		//Shows help 			
		}
	};
	var cancelTFAConfiguration = function(obj) {
		var modeId = $(obj).attr('modeId');
		$('#accordion_'+modeId).removeClass("accordion-section-selected");
		$('div[id^=help_links_div]').hide();			//Hides all help Links
		$('#help_links_div_default').show();			//Shows help
	};
	
	var insertTFAMacro = function(obj,id){
		var msg = $('textarea#'+id).val();  //No I18N
		msg = msg.replace("&nbsp;", " ");
		if(txtPosition == -1 && $(obj).val()!=null){
		msg+= "%" + $(obj).val() + "% ";
		}
		else if($(obj).val()!=null){
		msg = msg.slice(0, txtPosition) + "%"+$(obj).val()+"%" + msg.slice(txtPosition);
		}
		
		$( "div" ).find( ".jqte_editor" ).html(msg); //No I18N
		$('textarea#'+id).val(msg);  //No I18N
	};
	
	var doGetCaretPosition = function (editableDiv,event) {
		var caretPos = -1;			
		// IE Support
		if (document.selection) {
			// Set focus on the element
				editableDiv.focus();
			// To get cursor position, get empty selection range
			var oSel = document.selection.createRange();
			// Move selection start to 0 position
				oSel.moveStart('character', -editableDiv.value.length); //No I18N
			// The caret position is selection length
				caretPos = oSel.text.length;
		}
		// Firefox support
			else if (editableDiv.selectionStart || editableDiv.selectionStart == '0')
				caretPos = editableDiv.selectionStart;
		// Return results
		txtPosition =  caretPos;
		return true;
	}
	
//Methods to Manage TFA status ends here
	
	//Public Methods
	return{
		setTFAEnabled : setTFAEnabled,
		getTFAEnabled : getTFAEnabled,
		
		showSupportedTFAList : showSupportedTFAList,		// This method list all the supported TFA
		
		updateModeTFAStatus : updateModeTFAStatus,			//To Disable TFA Mode status alone
		updateModeTFAStatusCallBack : updateModeTFAStatusCallBack,			//To Disable TFA Mode status alone
		
		updateTFAStatus : updateTFAStatus,					//Manage TFA status
		setTFAStatusUI  : setTFAStatusUI,					//Sets the TFA status UI
		hideStatusDiv 	: hideStatusDiv,					//Hides TFA status div

		saveTFAConfiguration 	: saveTFAConfiguration,
		toggleModeConfiguration : toggleModeConfiguration,
		cancelTFAConfiguration 	: cancelTFAConfiguration,
		insertTFAMacro  		: insertTFAMacro,
		doGetCaretPosition      : doGetCaretPosition
	};
};
//Methods to Manage TFA status ends here

var TFALoginAuthenticator = new function(){	
	var validEmailErrorMessage = "";
	var validInputMessage = "";
	var selectTFAMode = function(modeId) {
		$("#tfalogin_" + modeId).prop('checked', true);
	};
	var setErrorMessage = function(rbEmailErrorMessage, rbvalidInputMessage) {
		validEmailErrorMessage = rbEmailErrorMessage;
		validInputMessage = rbvalidInputMessage;
	};
	var showTFAEnrollment = function() {
		var modeId = $("input[name='tfalogin']:checked").val();
		var modeName = $("#tfalogin_" + modeId).attr('modename');
		showTFAMode(modeId, modeName, "false", "0");
	};
	var showTFAMode = function(modeId, modeName, hasValidCoookie, errorMsg) {
		if(hasValidCoookie == 'true'){
			$('form[name="ValidCoookieTFA"]').submit();
		}
		else {
			var params = "modeName="+modeName+"&modeId="+modeId+"&errorcode="+errorMsg;										//NO I18N
			if(modeName != ""){
				$('#'+modeName+'_'+modeId).show();
				$('#tfaSelectionDiv').hide();
				AjaxAPI.sendRequest({URL:"/TFAConfigDiv.cc?methodToCall=showTFAEnrollment", PARAMETERS:params, ONSUCCESSFUNC:showSupportedTFAListSuccessDiv, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
			}
		}
	};	
	var showSupportedTFAListSuccessDiv = function(response, requestOptions) {
		document.getElementById('TFAEnrollmentDiv').innerHTML = response.responseText;		//No I18N
		$('#enrollmentDiv').show();					//No I18N
		$('#TFAEnrollmentDiv').show();				//No I18N
		
	};
	var showSupportedTFAListFailure = function(){
		DialogBox.alert("ads_admin_tfa_settings_alert_failure_msg");//NO I18N
	};		
	var enrollAndSendCodeMode = function(obj, errorMsg) {
		var modeId = $(obj).attr('modeId');
		var modeName = $(obj).attr('modeName');		
		enrollAndSendCodeTFA(modeId, modeName, '0');
	};
	var enrollAndSendCodeTFA = function(modeId, modeName, errorMsg) {
		if(modeName == 'TFA_MAIL_AUTHENTICATOR'){
			var emailId = $('#EMAIL').val();
			if(isValidEmail(emailId)){
				var params = "modeName="+modeName+"&modeId="+modeId+"&emailId="+emailId+"&errorcode="+errorMsg;   //NO I18N
				AjaxAPI.sendRequest({URL:"/TFAConfigDiv.cc?methodToCall=enrollAndSendCodeTFA", PARAMETERS:params, ONSUCCESSFUNC:showSupportedTFAListSuccessDiv, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
			}
			else{
				alert(validEmailErrorMessage);		//NO I18N
			}
		}
	};
	// Mail Authentication
	var isValidEmail = function(str) {
		var regexVal =/^[A-Z0-9_'%=+!`#~$*?^{}&|-]+([\.][A-Z0-9_'%=+!`#~$*?^{}&|-]+)*@[A-Z0-9-]+(\.[A-Z0-9-]+)+$/i; //NO I18N 
			if(regexVal.test(str)||((((str.split('%').length)%2)==1)&&(str.indexOf('%')>-1)))
			{	
				return true;	
			}
		return false;
	};	
	// Google Authenticator methods 
	var backTFA = function() {
		var modeId = $("input[name='tfalogin']:checked").val();
		var modeName = $("#tfalogin_" + modeId).attr('modename');
		
		$('#enrollmentDiv').hide();
		$('#tfaSelectionDiv').show();
	};
	
	var signOut = function() {
		
		try
		{	
			if(self!=top && (top.location.host==window.location.host || isSSOutEnabled))
			{
				window.WindowHandler.sendRequest(top,"SSOut",'[]'); // No I18n
			}
			else
			{
				$('form[name="SIGN_OUT"]').submit();
			}       
		}
		catch(e)
		{
				$('form[name="SIGN_OUT"]').submit();
		}	
	};
	var skipTFA = function() {
		$('form[name="skipTFA"]').submit();
	};
	var toggleSecretKeyRow = function() {
		$('#SecretKeyRow').toggle();
	};
	var changeDUOCookieStatus = function(obj) {		
		var cookieVal = $(obj).prop('checked');
		$('#enabledDuoCookie').val(cookieVal);
	};
	var hideStatusDiv = function() {
		$('#ErrorMessageDiv').hide();
	};
	var keyPressEvent = function(event) {
		if(event && (event.keyCode == 13 || event.which == 13))
		{
			TFALoginAuthenticator.verifyCode();
			return false;
		}
		else
		{
			return true;
		}
	};
	var backTFAMailEnrollment = function() {
		$('#mailEnrollDivStyle').show();
		$('#mailVerifyDivStyle').hide();
	};
	var verifyNewPinCode = function() {

		if($("input[id=rsa_new_pin]").val() == "")
		{
			var errMsg = $('#rsaEmptyAlert').text();			//NO I18N
			alert(errMsg);
			return;
		}
		if($("input[id=rsa_new_pin]").length > 0 && $("input[id=auth_code]").length > 0 && $("input[id=rsa_new_pin]").val() != $("input[id=auth_code]").val())
		{
			var errMsg = $('#rsaNotMatching').text();			//NO I18N
			alert(errMsg);
			return;
		}

		if($('#rsa_new_pin').val().search(new RegExp($('#rsa_new_pin').attr('patternText'))) < 0)
		{
			var invalidPatternMsg = $('#rsaInvalidPatternAlert').text();			//NO I18N
			alert(invalidPatternMsg);
			return;
		}
		verifyCode();
	};
	var verifyCode = function() {
		var d = new Date();
		var time = d.getTime();
		var verificationCode = $('#auth_code').val();
		
		if(verificationCode == ''){
			alert(validInputMessage);
			return;
		}
		
		$('#confirmationCode').val(verificationCode);
		$('#TIME').val(time);
		var cookieVal = $('#cookie_remember').prop('checked');
		$('#enabledCookie').val(cookieVal);
		$('form[name="VerificationTFA"]').submit();
	};
	
	//Public Methods
	return{
		selectTFAMode	  	 : selectTFAMode,
		showTFAEnrollment 	 : showTFAEnrollment,
		showTFAMode		 	 : showTFAMode,
		enrollAndSendCodeMode: enrollAndSendCodeMode,
		enrollAndSendCodeTFA : enrollAndSendCodeTFA,
		keyPressEvent		 : keyPressEvent,
		
		// Google Authenticator methods 
		signOut 		  	 : signOut,
		backTFA 		  	 : backTFA,
		skipTFA 		  	 : skipTFA,
		toggleSecretKeyRow	 : toggleSecretKeyRow,
		hideStatusDiv 		 : hideStatusDiv,
		changeDUOCookieStatus: changeDUOCookieStatus,
		backTFAMailEnrollment: backTFAMailEnrollment,
		setErrorMessage		 : setErrorMessage,
		verifyNewPinCode 	 : verifyNewPinCode,
		verifyCode 		  	 : verifyCode
	};
};


var TFASelfConfig = new function(){	
	var isTFAEnabled = false;
	var popUpParams = "";
	var getIsEnabled = function(){
		return isTFAEnabled;
	};
	var setTFAStatusUI = function(tfaStatus, refreshConfiguredTFADetails, reloadEnrollmentPage){
		if(tfaStatus == "true"){
			$(".switch span").css("background-color", "#4bd663");
			$(".switch span i").css("left", "14px");
			$(".switch .green").css("display", "block");
			$(".switch .gray").css("display", "none");
			$('#TFAStatus').attr('isEnabled', 'true');
			isTFAEnabled = true;
		}
		else{
			$(".switch span").css("background-color", "#ccc");
			$(".switch span i").css("left", "0px");
			$(".switch .green").css("display", "none");
			$(".switch .gray").css("display", "block");
			$('#TFAStatus').attr('isEnabled', 'false');
			isTFAEnabled = false;
		}
		
		if(refreshConfiguredTFADetails == "true"){
			showTFASelfConfig();			
		}
		else if(reloadEnrollmentPage == "true"){
			showTFAEnrollment();			
		}
	};
	var showTFAList = function(){
		hideAllSelfUpdateDiv();
		$('#TFAListDiv').show();
	};
	var backTFADioEnrollment = function(){
		window.parent.TFASelfConfig.showTFASelfConfig();
	};
	var backTFASelfEnrollment = function(){
		hideAllSelfUpdateDiv();
		$('#TFAListDiv').show();
	};
	var backTFASelfVerification = function(){
		hideAllSelfUpdateDiv();
		$('#TFAEnrollmentDiv').show();
	};
	var cancelTFASelfUpdate = function(){
		hideAllSelfUpdateDiv();
		$('#TFASelfUpdateDiv').show();
	};
	var hideAllSelfUpdateDiv = function(){
		$('#TFASelfUpdateDiv').hide();
		$('#TFAListDiv').hide();
		$('#TFAEnrollmentDiv').hide();
		$('#TFAVerificationDiv').hide();
	};
	var updateTFAStatus = function(obj){
		var isEnabled = $('#TFAStatus').attr('isEnabled');
		var params = "updateStatus="+isEnabled;															//NO I18N

		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=updateSelfUpdateTFA", PARAMETERS:params, ONSUCCESSFUNC:loadTFAStatusSuccess, ONFAILUREFUNC:showSupportedTFAListFailure});								 //NO I18N
	};	
	var loadTFAStatusSuccess = function(response, requestOptions){
		document.getElementById('selfTFAMessageDiv').innerHTML = response.responseText;				//No I18N
		
	};
	
// Methods to list all the supported TFA STARTS here
	var showTFASelfConfig = function() {
		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=showUserTFADetails", ONSUCCESSFUNC:showSupportedTFAListSuccess, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
	};
	var showSupportedTFAListSuccess = function(response, requestOptions) {
		document.getElementById('TFASelfUpdateConfigDiv').innerHTML = response.responseText;				//No I18N
	};
// Methods to list all the supported TFA ENDS here	
	
	
	var showTFAEnrollment = function() {
		
		var modeId = $("input[name='tfalogin']:checked").val();
		var modeName = $("#tfalogin_" + modeId).attr('modename');
		
		if(modeName != ""){
			var params = "modeName="+modeName+"&modeId="+modeId;//No I18N
			AjaxAPI.sendRequest({URL:"/TFAConfigDiv.cc?methodToCall=showTFASelfEnrollment", PARAMETERS:params, ONSUCCESSFUNC:showTFAEnrollmentSuccess, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
		}	
	};
	var showTFAEnrollmentSuccess = function(response, requestOptions) {
		document.getElementById('TFAEnrollmentDiv').innerHTML = response.responseText;				//No I18N
		hideAllSelfUpdateDiv();								 //No I18N
		$('#TFAEnrollmentDiv').show();						 //No I18N
	};
	var showSuccessMessageDiv = function(responseMsg) {
		$('#selfTFASuccessMessageDiv').text(responseMsg);						 //No I18N
		$('#selfTFAMessageDiv').show();						 //No I18N
		$('#statusMessageDiv').show();						 //No I18N
	};
	var showTFAVerificationPage = function(obj) {		
		var modeId = $(obj).attr('modeId');
		var modeName = $(obj).attr('modename');
		
		var params = "modeName="+modeName+"&modeId="+modeId;//No I18N
		if(modeName == 'TFA_MAIL_AUTHENTICATOR') {
			var emailId = $('#EMAIL').val();
			params = params + "&mailId="+emailId;//No I18N
			
			if(isValidEmail(emailId)){
				AjaxAPI.sendRequest({URL:"/TFAConfigDiv.cc?methodToCall=showTFASelfVerification", PARAMETERS:params, ONSUCCESSFUNC:showTFAVerificationSuccess, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
			}
			else{
				DialogBox.alert("ads_admin_tfa_settings_please_enter_a_valid_email_id");//NO I18N
			}
		}	
	};
	var showTFAVerificationSuccess = function(response, requestOptions) {
		document.getElementById('TFAVerificationDiv').innerHTML = response.responseText;				//No I18N
	};
	var verifyCode = function(obj) {
		var modeId = $(obj).attr('modeId');
		var modeName = $(obj).attr('modename');
		var confirmationCode = $("#auth_code").val();
		
		var d = new Date();
		var time = d.getTime();
		
		if(modeName != ""){
			var params = "modeName="+modeName+"&modeId="+modeId+"&confirmationCode="+confirmationCode+"&time="+time;//No I18N
			AjaxAPI.sendRequest({URL:"/TFAConfigDiv.cc?methodToCall=verifySelfUpdateTFA", PARAMETERS:params, ONSUCCESSFUNC:verifySelfUpdateTFASuccess, ONFAILUREFUNC:showSupportedTFAListFailure});//NO I18N
		}
		
	};	
	var verifySelfUpdateTFASuccess = function(response, requestOptions) {
		document.getElementById('selfTFAMessageDiv').innerHTML = response.responseText;	//No I18N
		$('#selfTFAMessageDiv').show();						 							//No I18N
		
	};
	var showSupportedTFAListFailure = function(){
		DialogBox.alert("ads_admin_tfa_settings_alert_failure_msg");//NO I18N
	};
	var hideMessageDiv = function(){
		$('#selfTFAMessageDiv').hide();
	};
	var deleteTFATrustedBrowsers = function(id, deleteAll){
		popUpParams = "id="+id+"&deleteAll="+deleteAll;	//NO I18N
		DialogBox.confirm("ads_admin_tfa_settings_r_u_sure_to_delete_tfa_trusted_browsers", "TFASelfConfig.deleteTFATrustedBrowsersCallBack");//NO I18N
	};
	var deleteTFAEnabledUsers = function(id,deleteAll){
		popUpParams = "id="+id+"&deleteAll="+deleteAll;	//NO I18N
		DialogBox.confirm("ads_admin_tfa_settings_r_u_sure_to_delete_tfa_enabled_users", "TFASelfConfig.deleteTFAEnabledUsersCallBack");//NO I18N
	};
	
	var deleteTFATrustedBrowsersCallBack = function(){
		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=deleteTFATrustedBrowsers", PARAMETERS:popUpParams, ONSUCCESSFUNC:refreshTrustedBrowsersView});	//NO I18N
	};
	var deleteTFAEnabledUsersCallBack = function(){
		AjaxAPI.sendRequest({URL:"/TFAConfigDiv.do?methodToCall=deleteTFAEnabledUsers", PARAMETERS:popUpParams, ONSUCCESSFUNC:refreshEnabledUsersView});	//NO I18N
	};
	var refreshTrustedBrowsersView = function(){
		PopupDataModel.refreshView(97);
	};
	var refreshEnabledUsersView = function(){
		PopupDataModel.refreshView(96);
	};
	var openPopUP = function(popupId){
		PopupSelection.openPopup(popupId);
	};
	var showTFAPopOK = function(){
		DialogBox.closeDialog();
	};
	var getHeaderInputsJson = function(){

	};
	
		
		
	var showPersonalisePopUp = function(){
		AjaxAPI.sendRequest({URL:"/personalisePage.do?methodToCall=showPersonalisePopUp", ONSUCCESSFUNC:TFASelfConfig.showPersonalisePopUpSuccess, ONFAILUREFUNC:TFASelfConfig.showPersonalisePopUpFailed});  //NO I18N
	}
	var showPersonalisePopUpSuccess = function(response,requestOptions)
	{
		var width = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
		var height =  window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
		var top = 0;
		var left = 0;		
		if(width > 700) left = (width - 800)/2;
		if(height > 550) top = (height - 550)/2;

		showDialog(response.responseText,"position=absolute,top="+top+", left="+left+", width=695, customsetting=true,closeOnEscKey=yes,closeButton=no,draggable=no,modal=yes,freezeLayerBGColor=#000B0B", null, TFASelfConfig.hideFieldHelp);  //NO I18N

		$('#_DIALOG_CONTENT').css("overflow", "");
	}
	var showPersonalisePopUpFailed = function(){
		
	}
	var hideFieldHelp = function(){
		closeDialog();
	};

	
	var isValidEmail = function(str) {
		var regexVal =/^[A-Z0-9_'%=+!`#~$*?^{}&|-]+([\.][A-Z0-9_'%=+!`#~$*?^{}&|-]+)*@[A-Z0-9-]+(\.[A-Z0-9-]+)+$/i; //NO I18N 
			if(regexVal.test(str)||((((str.split('%').length)%2)==1)&&(str.indexOf('%')>-1)))
			{	
				return true;	
			}
		return false;
	};	
	//Public Methods
	return{
		showPersonalisePopUp	: showPersonalisePopUp,
		hideFieldHelp			: hideFieldHelp,
		showPersonalisePopUpFailed	: showPersonalisePopUpFailed,
		showPersonalisePopUpSuccess	: showPersonalisePopUpSuccess,
		
		
		updateTFAStatus	  	 	: updateTFAStatus,
		deleteTFAEnabledUsers	: deleteTFAEnabledUsers,
		deleteTFATrustedBrowsers: deleteTFATrustedBrowsers,
		showTFASelfConfig	  	: showTFASelfConfig,
		showTFAEnrollment	  	: showTFAEnrollment,
		showTFAVerificationPage	: showTFAVerificationPage,
		verifyCode 			  	: verifyCode,
		openPopUP 		 	 	: openPopUP,
		showTFAPopOK 		  	: showTFAPopOK,
		getHeaderInputsJson	  	: getHeaderInputsJson,
		deleteTFATrustedBrowsersCallBack	: deleteTFATrustedBrowsersCallBack,
		deleteTFAEnabledUsersCallBack	  	: deleteTFAEnabledUsersCallBack,
	
		showSuccessMessageDiv	: showSuccessMessageDiv,	
		hideAllSelfUpdateDiv	: hideAllSelfUpdateDiv,	
		hideMessageDiv			: hideMessageDiv,	
		setTFAStatusUI	  	 	: setTFAStatusUI,
		showTFAList	  			: showTFAList,
		backTFADioEnrollment	: backTFADioEnrollment,
		backTFASelfEnrollment	: backTFASelfEnrollment,
		backTFASelfVerification	: backTFASelfVerification,
		cancelTFASelfUpdate	 	: cancelTFASelfUpdate		
	};
};
