/*
 * $Id: Integration.js,v 1.24 2016/05/18 06:53:15 navin.rathinasamy Exp $
 */
var Integration=function(){
}

Integration.getComponentStatusToolTip=function()
{
	if(jumpToObject!=null)
	{
		for(var i=0;i<jumpToObject.length;i++)
		{	
			var s=jumpToObject[i];
			$("#"+s["PRODUCT_ID"]+"_INTEGRATION_STATUS").removeClass("adsServerDown adsServerUp").addClass(s["SERVER_STATUS"]); //No I18N
			$("#"+s["PRODUCT_ID"]+"_ARROW").attr('TOOL_TIP_MSG',s["TOOL_TIP"]); //No I18N
		}
	}
	else{setTimeout(function(){Integration.getComponentStatusToolTip();},200);}
}

Integration.validateEntries=function(name)
{	
	var host=$('[id="'+name+'"] [name="HOST"]').val();
	var port=$('[id="'+name+'"] [name="PORT"]').val();
	var userName=$('[id="'+name+'"] [name="USERNAME"]').val();
	var pwd=$('[id="'+name+'"] [name="PASSWORD"]').val();
	var authRequired=$('[id="'+name+'"] [name="IS_AUTH_REQUIRED"]').val();

	if((host == '')||(port ==''))
	{
		DialogBox.alert(jsRb.ads_admin_integration_settings_alert_entries_notnull);
		return false;
	}
	if(authRequired=='true' && ((userName =='')||(pwd =='')))
	{
		DialogBox.alert(jsRb.ads_admin_server_settings_alert_user_pwd);
		return false;
	}
	if(!port.match(/^\d+$/i))
	{
		DialogBox.alert(jsRb.ads_admin_integration_settings_alert_prt_number);
		return false;
	}
	var numPort=Number(port);
	if((numPort<=0 || numPort>65535)) 
	{
		DialogBox.alert(jsRb.ads_admin_integration_settings_alert_prt_range); //No I18N
		return false;
	}
	if(host.endsWith("."))
  	{
  		DialogBox.alert(jsRb.ads_admin_integration_settings_alert_hostname_cannot_end_with_dot);
  		return false;
  	}
	
	return true;
}

Integration.saveSettings=function(name,updateType)
{	
	if(Integration.validateEntries(name))
	{
		$('[id="'+name+'"] [name="mTCall"]').val('save');
		$('[id="'+name+'"] [name="UPDATE_TYPE"]').val(updateType);
		$('[id="'+name+'"]').submit();
	}
}

Integration.cancel=function(name)
{
	$('[id="'+name+'"] [name="mTCall"]').val('unspecified');
	$('[id="'+name+'"] [name="UPDATE_TYPE"]').val('cancel');
	$('[id="'+name+'"]').submit();
}

Integration.enableDisable=function(productName,isEnabled)
{
	var form = document.getElementById(productName);
	var elements = form.elements;
	for (var i = 0, len = elements.length; i < len; ++i) {
		elements[i].disabled = false;
	}
	
	$('[id="'+productName+'"] [name="mTCall"]').val('enableDisable');
	$('[id="'+productName+'"] [name="UPDATE_TYPE"]').val('cancel');
	$('[id="'+productName+'"]').submit();
}

Integration.remove=function(name)
{
	if(Integration.validateEntries(name))
	{
		var productId=$('[id="'+name+'"] [name="PRODUCT_ID"]').val();
		var displayName=$("#"+productId+"_INTEGRATION_STATUS").closest("div[SUB_TAB_ID]").attr("SUB_TAB_ID");
		if($("#"+productId+"_INTEGRATION_STATUS").hasClass("adsServerDown"))
		{
			DialogBox.confirm(jsRb.ads_admin_integration_settings_confirm_delete_details_not_removed.replace("{0}",displayName),"Integration.removeConfirm('"+name+"')"); //No I18N
		}
		else if($("#"+productId+"_INTEGRATION_STATUS").hasClass("adsServerUp"))
		{
			DialogBox.confirm(jsRb.ads_admin_integration_settings_confirm_delete.replace("{0}",displayName),"Integration.removeConfirm('"+name+"')"); //No I18N
		}
	}
}

Integration.removeConfirm=function(name)
{
	$('[id="'+name+'"] [name="mTCall"]').val('remove');
	$('[id="'+name+'"] [name="UPDATE_TYPE"]').val('remove');
	$('[id="'+name+'"]').submit();
}

Integration.synchronizeNow=function(sStatus)
{
	var buttonData=$('#syncNowButtonTxt').html(); //No I18N
	var statusStyle = "adssuccessStatusMsg";//NO I18N
	var iconStyle= "adssuccessSmallIcon";//NO I18N
	var statusMsg = jsRb.ads_admin_integration_settings_syncnow_success;
	var reason="";
	$('#SYNC_NOW_ICON').removeClass('adSyncNowIcon');
	$('#SYNC_NOW_ICON').html("<img src='images/adsf/common/ads-loading.gif'/>");
	$('#syncNowButtonTxt').html(jsRb.ads_admin_integration_settings_button_synchronizing); //No I18N
	$.post('Integration.do?mTCall=synchronizeNow', function(data)//No I18N 
	{  

		if(data=='Failure')   //No I18N
		{
			$('#syncNowMSG').html(jsRb.ads_admin_integration_settings_syncnow_failure);  //No I18N
		}
		else 
		{
			var obj = jQuery.parseJSON(data);
			for(var i=0;i<obj.length;i++)
			{
				var s=obj[i];
				for(var key in s)
				{
					if(key=="EXCEPTION")
					{
						statusStyle = "adserrorStatusMsg";//NO I18N
						iconStyle = "adsfailureSmallIcon";//NO I18N
						statusMsg = jsRb.ads_admin_integration_settings_syncnow_failure + '  <a class="adscursorPointer" onclick="DialogBox.open(\'POPUP_BOX\');">'+jsRb.ads_admin_integration_settings_syncnow_reason+'</a>';//NO I18N
						reason=reason+"<div><table><tr class='adsfontSize11 adsgrayFont adsfntFamily'><td valign=top><div style='float:left;margin-top:5px;margin-right:5px;' class='adsblKBullet'></div></td><td><div style='float:left'> "+s["PRODUCT_NAME"]+" - "+ s[key]+"</div></td></tr></table></div>"; 
					}
					else if((key=="STATUS")&&(s[key]=="false"))
					{
						statusStyle = "adserrorStatusMsg";//NO I18N
						iconStyle = "adsfailureSmallIcon";//NO I18N
						statusMsg = jsRb.ads_admin_integration_settings_syncnow_failure + '  <a class="adscursorPointer" onclick="DialogBox.open(\'POPUP_BOX\');">'+jsRb.ads_admin_integration_settings_syncnow_reason+'</a>';//NO I18N
						reason=reason+"<div><table><tr class='adsfontSize11 adsgrayFont adsfntFamily'><td valign=top><div style='float:left;margin-top:5px;margin-right:5px;' class='adsblKBullet'></div></td><td><div style='float:left'>"+s["PRODUCT_NAME"]+" - "+ jsRb.ads_admin_integration_settings_syncnow_cannotcontact+"</div></td></tr></table></div>";
					}
				}
			}
			$('#POPUP_CONTENT').html("<div style=\'padding-bottom:5px;\'><b>"+jsRb.ads_admin_integration_settings_popup_head_reason+" :</b></div>"+reason);
		}
		$('#FORM_STATUS').attr('class','adsfntFamily adsfontSize11 '+statusStyle);
		$("#FORM_STATUS div:nth-child(1)").attr('class','adsflLeft '+iconStyle);//NO I18N
		$("#FORM_STATUS div:nth-child(2)").html(statusMsg);

		$('#syncNowButtonTxt').html(jsRb.ads_admin_integration_settings_button_syncnow); //No I18N
		$('#SYNC_NOW_ICON').html('');//NO I18N
		$('#SYNC_NOW_ICON').addClass('adSyncNowIcon'); //No I18N
		
		// To Display the status message
		ADSUtil.slideDown('FORM_STATUS');//NO I18N
		if(sStatus!=null)
		{
		window.WindowHandler.sendRequest(parent.parent,'reloadAppsPane','[]'); //NO I18N
		}
	});

	//Removing integarted products loaded iframe

	window.WindowHandler.sendRequest(parent.parent,'removeChildIframes','[]'); //NO I18N
}
Integration.enableAuthentication=function(productId,productName,th)
{
 if($(th).find('[name="IS_AUTH_REQUIRED"]').val()=='true')
 {
	$('[id="'+productName+'"] [name="USERNAME"]').val('');
	$('[id="'+productName+'"] [name="PASSWORD"]').val('');
 }
 $('#AUTHENTICATE_'+productId).toggle();
}