/*
 * $Id: ServerSettings.js,v 1.5 2016/05/13 12:44:43 navin.rathinasamy Exp $
 */
var emailFilter=/^\w+[\+\.\w-]*@([\w-]+\.)*\w+[\w-]*\.([a-z]+)$/i
var ServerSettings=function()
{
}
ServerSettings.validateMailSettings=function()
{
	var serverName=$.trim($('#MAIL_SETTINGS [name="SERVER_NAME"]').val());
	var port=$.trim($('#MAIL_SETTINGS [name="PORT"]').val());
	var userName=$.trim($('#MAIL_SETTINGS [name="USER_NAME"]').val());
	var pwd=$.trim($('#MAIL_SETTINGS [name="PASSWORD"]').val());
	var fromId=$.trim($('#MAIL_SETTINGS [name="FROM_MAIL_ID"]').val());
	var adminId=$.trim($('#MAIL_SETTINGS [name="ADMIN_MAIL_ID"]').val());
	//Check for the port(Must be a number)

	//Check for the authentication details
	if($('#ENABLE_AUTHENTICATION').hasClass('adscustomUncheckBox'))
	{
		if((userName =='')||(pwd ==''))
		{
			DialogBox.alert(jsRb.ads_admin_server_settings_alert_user_pwd);
			return false;
		}
	}
	else
	{
		$('#MAIL_SETTINGS [name="USER_NAME"]').val('');
		$('#MAIL_SETTINGS [name="PASSWORD"]').val('');
	}
	//Check for null entries
	if((serverName == '')||(port =='')||(fromId =='')||(adminId ==''))
	{
		DialogBox.alert(jsRb.ads_admin_server_settings_alert_prt_server_mailid);
		return false;
	}
	//Check for port entry
	if(!port.match(/^\d+$/i))
	{
		$('#MAIL_SETTINGS [name="PORT"]').focus();
		DialogBox.alert(jsRb.ads_admin_server_settings_alert_prt_number);
		return false;
	}
	var numPort=Number(port);
	if((numPort<=0 || numPort>65535)) 
	{
		$('#MAIL_SETTINGS [name="PORT"]').focus();
		DialogBox.alert(jsRb.ads_admin_server_settings_alert_prt_range); //No I18N
		return false;
	}
	//Check for valid mail address
	if(!emailFilter.test(fromId))
	{	
		if(fromId.length>40)
		{
			var str='';
			for(var len=0;len<=fromId.length;len+=40)
			{
				str = str+fromId.substring(len, len+40)+" ";
			}
			fromId=str;
		}
		DialogBox.alert(jsRb.ads_admin_server_settings_alert_invalid_fromaddress+" : "+fromId);
		return false;
	}
	var array=adminId.split(",");
	for(var i=0;i<array.length;i++)
	{
		if(!emailFilter.test($.trim(array[i])))
		{
			if($.trim(array[i])!="")
			{
				if(array[i].length>40)
				{
					var str='';
					for(var len=0;len<=array[i].length;len+=40)
					{
						str = str+array[i].substring(len, len+40)+" ";
					}
					array[i]=str;
				}
				DialogBox.alert(jsRb.ads_admin_server_settings_alert_invalid_toaddress+" : "+array[i]);
				return false;
			}
		}
	}
	for(var i=0;i<array.length-1;i++)
	{
		for(var j=i+1;j<array.length;j++)
		{
			if($.trim(array[i])=="")
			{
				DialogBox.alert(jsRb.ads_admin_server_settings_alert_invalid_toaddress);
				return false;
			}
			else if($.trim(array[i])==$.trim(array[j]))//Check for same to addressess
			{
				DialogBox.alert(jsRb.ads_admin_server_settings_alert_sameaddress);
				return false;
			}
		}
	}
	return true;
}
ServerSettings.saveMailSettings=function()
{
	var serverName=$.trim($('#MAIL_SETTINGS [name="SERVER_NAME"]').val());
	var port=$.trim($('#MAIL_SETTINGS [name="PORT"]').val());
	var fromId=$.trim($('#MAIL_SETTINGS [name="FROM_MAIL_ID"]').val());
	var toId=$.trim($('#MAIL_SETTINGS [name="ADMIN_MAIL_ID"]').val());
	var conSec=$('#MAIL_SETTINGS [name="CONNECTION_SECURITY_ID"]').val();
	var enableHtml=$('#MAIL_SETTINGS [name="ENABLE_HTML_FORMAT"]').val();
	var isEnabled=$('#MAIL_SETTINGS [name="IS_ENABLED"]').val();
	var licenseExpiry=$('#MAIL_SETTINGS [name="ENABLE_LICENSE_EXPIRY"]').val();
	
	var url = "ServerSettings.do?selTab=admin&selTile=serverSetting&mTCall=mailSettings";//NO I18N
	//validation done for resonable entries.
	if(ServerSettings.validateMailSettings())
	{
		var userName=$.trim($('#MAIL_SETTINGS [name="USER_NAME"]').val());
		var pwd=$.trim($('#MAIL_SETTINGS [name="PASSWORD"]').val());
		//Open the loading div
		$('#loadingMessage').html(jsRb.ads_admin_server_settings_saving);//NO I18N
		$('#loading').css("display", "block");
		var params="SERVER_NAME="+serverName+"&PORT="+port+"&FROM_MAIL_ID="+fromId+"&ADMIN_MAIL_ID="+toId+"&USER_NAME="+userName+"&PASSWORD="+pwd+"&CONNECTION_SECURITY_ID="+conSec+"&ENABLE_HTML_FORMAT="+enableHtml+"&ENABLE_LICENSE_EXPIRY="+licenseExpiry+"&IS_ENABLED="+isEnabled;//NO I18N
		AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ServerSettings.load});
		$("html, body").animate({ scrollTop: 0 }, "slow");//NO I18N	
	}
}
ServerSettings.hide=function()
{
	//hide the authentication details
	$('#AUTHENTICATE').css('display','none');
}
ServerSettings.testMail=function()
{

	var serverName=$.trim($('#MAIL_SETTINGS [name="SERVER_NAME"]').val());
	var port=$.trim($('#MAIL_SETTINGS [name="PORT"]').val());
	var userName=$.trim($('#MAIL_SETTINGS [name="USER_NAME"]').val());
	var pwd=$.trim($('#MAIL_SETTINGS [name="PASSWORD"]').val());
	var fromId=$.trim($('#MAIL_SETTINGS [name="FROM_MAIL_ID"]').val());
	var toId=$.trim($('#MAIL_SETTINGS [name="ADMIN_MAIL_ID"]').val());
	var conSec=$('#MAIL_SETTINGS [name="CONNECTION_SECURITY_ID"]').val();
	var enableHtml=$('#MAIL_SETTINGS [name="ENABLE_HTML_FORMAT"]').val();

	//validation done for resonable entries.
	if(ServerSettings.validateMailSettings())
	{
		//Open the loading div
		$('#loadingMessage').html(jsRb.ads_admin_server_settings_sending);//NO I18N
		$('#loading').css("display", "block");
		var url = "ServerSettings.do?selTab=admin&selTile=serverSetting&mTCall=sendTestMail";//NO I18N
		var params="SERVER_NAME="+serverName+"&PORT="+port+"&FROM_MAIL_ID="+fromId+"&ADMIN_MAIL_ID="+toId+"&USER_NAME="+userName+"&PASSWORD="+pwd+"&CONNECTION_SECURITY_ID="+conSec+"&ENABLE_HTML_FORMAT="+enableHtml;//NO I18N
		AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ServerSettings.load}); 
		$("html, body").animate({ scrollTop: 0 }, "slow");//NO I18N
	}
}
ServerSettings.load=function(response)
{
	var statusStyle;
	var iconStyle;
	var jsonObject = response.transport;
	//Close the loading div
	$('#loading').css("display", "none");
	var obj = jQuery.parseJSON(jsonObject.responseText);
	for(var key in obj)
	{
		if(key=='sSTATUS')
		{
			statusStyle = "adssuccessStatusMsg";//NO I18N
			iconStyle = "adssuccessSmallIcon";//NO I18N
		}
		else if(key=='eSTATUS')
		{
			statusStyle = "adserrorStatusMsg";//NO I18N
			iconStyle = "adsfailureSmallIcon";//NO I18N
		}
		else if(key=='wSTATUS')
		{
			statusStyle = "adswarningStatusMsg";//NO I18N
			iconStyle = "adswarningSmallIcon";//NO I18N
		}
		$('#FORM_STATUS').attr('class','adsfntFamily adsfontSize11 '+statusStyle);
		$("#FORM_STATUS div:nth-child(1)").attr('class','adsflLeft '+iconStyle);//NO I18N
		$("#FORM_STATUS div:nth-child(2)").html(obj[key]);
	}
	// To Display the status message
	ADSUtil.slideDown('FORM_STATUS');//NO I18N
	var timer = setInterval(function(){
		clearInterval(timer);
		ADSUtil.slideUp('FORM_STATUS');}, 5000);//NO I18N
}
