/*
 * $Id: Dashboard.js,v 1.11 2016/07/15 10:04:21 gokulkumar.v Exp $
 */

var Dashboard = function(){
}

var previousUniqueId=0;

Dashboard.loadDashboardLayout = function(elem)
{
	var params = Layout.getParameters();

	if(params["domainName"] != elem.id) 
	{
		params["domainName"] = elem.id;
		params = JSON.stringify(params);
		Dashboard.loadLayout(params);
	}
}

Dashboard.loadLayout = function(params)
{
	//Parsing the string to JSON Object
	//And assigning the parameters in local memory
	Layout.parameters = jQuery.parseJSON(params);

	//Open the loading div
	$('#loading').toggle();

	var url = "/ADSLayout.do?mTCall=loadLayout";//NO I18N
	var params = "userId="+Layout.getParameters().userId+"&params="+JSON.stringify(Layout.getParameters());//NO I18N
	AjaxAPI.sendRequest({URL:url, PARAMETERS:params, ONSUCCESSFUNC:Dashboard.loadLayoutContent, ONFAILUREFUNC:Layout.failedToLoad, TAB_ID:Layout.getParameters().tabId}); 
}

Dashboard.loadLayoutContent = function(response, reqOptions)
{
	var jsonObject = response.transport;  

	//Close the loading div
	$('#loading').css("display", "none");

	//Loading the layout content
	$('#LAYOUTS').delay(800).html(jsonObject.responseText);//No I18N 

	//Removing the tabContainer created by framework
	$('#TAB_'+Tab.getSelectedTabId()+'_CONTAINERS').remove();//No I18N

	//Load Product Containers : It will call product API and load the Containers.
	var tabId = reqOptions["TAB_ID"];
	tabId = (typeof(tabId) != "undefined" ? tabId : Tab.getSelectedTabId());//NO I18N

	Dashboard.loadContainers(tabId, true);//True : Force to load the Containers
}

Dashboard.loadContainers = function(tabId, forceLoad)
{
	if(!$('#TAB_'+tabId+'').hasClass("adsDBenableTab") || forceLoad)//Already in selected tab or load the container if forceLoad is true
	{

		//Open the loading div
		$('#loading').toggle();
		//Toggle to the selected tab	 
		Tab.toggleTabs(tabId); 

		//Loading the selected tab's containers
		if(!eval(document.getElementById("TAB_"+tabId+"_CONTAINERS")) || forceLoad)//TabContainers doesn't exist
		{
			var url = "Dashboard.do?mTCall=loadContainers";//NO I18N

			//Appending the requried parameters 
			//with the layout parameters
			var params = Layout.getParameters();
			params["tabId"] = tabId;

			//Converting the JSON object to string
			params = "userId="+Layout.getParameters().userId+"&params="+JSON.stringify(params);//No I18N

			AjaxAPI.sendRequest({URL:url, PARAMETERS:params, ONSUCCESSFUNC:Dashboard.loadContainerContent, ONFAILUREFUNC:Container.failedToLoad, TAB_ID:tabId}); 

		}//Already exist so just toggle to it
		else
		{
			Container.toggleTabContainers("TAB_"+tabId+"_CONTAINERS");//No I18N 
			var params = Layout.getParameters();
			if(params == null) 
			{
				params = jQuery.parseJSON('{}'); 
			}
			params["tabId"] = tabId;//No I18N 
			Layout.parameters = params;
		}
	}
}

Dashboard.loadContainerContent = function(response, reqOptions)
{
	//Call the Framework Container.load(equivalent to super.load)
	Container.load(response, reqOptions);

	//Load RHS Components
	LayoutUtil.triggerFunction('LoadRHSComponents');
}

Dashboard.loadComponent = function(th)
{
	var type = Container.getSelectedType(th);
	var duration = Container.getSelectedDuration(th);

	/*
	 * If duration is undefined need to assign default duration -1.
	 * Which means the corresponding component doesn't need the duration.
	 */
	duration = (typeof duration == 'undefined' ? -1 : duration);//No I18N

	var componentName = type+"_"+duration;
	var uniqueId = (new Date()).getTime();
	if(uniqueId<=previousUniqueId)
	{
		uniqueId=previousUniqueId+1;
	}
	previousUniqueId=uniqueId;

	//Check whether the container component exist
	var isComponentExist = ($(th).find("div[FW='COMPONENT'][NAME='"+componentName+"']").length > 0);

	//Loading the component
	if(!isComponentExist)//ContainerComponent doesn't exist
	{
	    	var url =  "/ADSLayout.do?mTCall=loadComponent"; // No I18n
		var isRHS=($(th).parent().get(0).id == "RHS_CONTAINERS"?true:false);

		//Appending the requried parameters 
		//with the layout parameters
		var params = Layout.getParameters();
		params["containerId"] = th.attr("id");//No I18N
		params["tabId"] = Tab.getSelectedTabId();
		params["type"] = type;
		params["duration"] = duration;
		params["IS_RHS"]=isRHS;
		uniqueId=uniqueId+"_"+componentName;

		//Converting the JSON object to string
		params = "params="+JSON.stringify(params);//No I18N

		//Creating new div to hold the component
		var ele = document.createElement("div");
		ele.setAttribute("FW", "COMPONENT");
		ele.setAttribute("NAME", componentName);
		ele.id = uniqueId;

		//Appending the newly created div to the component
		$(th).find("div[FW='COMPONENTS']").append(ele);

		AjaxAPI.sendRequest({URL:url, PARAMETERS:params, ONSUCCESSFUNC:Component.load, ONFAILUREFUNC:Component.failedToLoad, UNIQUE_ID:uniqueId}); 
	}

	//Toggle to the component div before loading the content
	Component.toggleComponent(th, componentName);

	//Hide the loading
	$(th).find("div[FW='COMPONENT_LOADING']").css('display', 'none');
}

Dashboard.loadDomainList = function(response, reqOptions)
{
	var toWrite = '<div class="adsflLeft adsmargin5 adslineHeight" id="SELECT_DOMAIN_VIEW"> <div class="adsfontSize10 adsflLeft">' + jsRb.ads_home_layout_header_select_domain + '&nbsp;</div> <div class="adsflLeft">';

	toWrite += response.transport.responseText;

	toWrite += '</div> <div class="adsclearAll"></div> </div>';

	$('#DOMAIN_LIST').html(toWrite); //No I18N
}

//Empty function to avoid script error
Dashboard.toggleRefresh = function(id) {}

Dashboard.changeDomain = function(domain)
{
	var params = Layout.getParameters();
	if(params["domainName"] != domain) 
	{
		params["domainName"] =domain;
		adsLayout["COMPONENT"].send('updateParams','domainName',domain); // No i18n
	}
}